
#include "st2.h"

	char *version="4.00";

	char scorefile[]="st2score.dat";
	char musicfile[]="st2music.dat";
	char savedfile[]="st2game1.sav";
	char filename[14]="filename.ext";
	char gamename[16];



//============================================================================
// 3D Objects Data:
//    ox, oy, oz - coordinates of points
//    oln - lines data
//    opl - polygones data
//    osf - surfaces data (of polygones)
//    opon - object points number
//    olin - object lines number
//    opln - object polygones number


	int ox0 []  = {-75,65,65,-75, 65,65, -75,-75};
	int oy0 []  = {-115,-115,125,125, 125,-115, 125,-115};
	int oz0 []  = {0,0,0,0, 10,10, 10,10};
	int oln0 [] = {0,1,2};
	int opl0 [] = {0,1,2,3,0,-3, 1,2,4,5,1,-2, 0,3,6,7,0,-2, 0,1,5,7,0,-2};
	int osf0 [] = {0,6,12,18};
	int opon0 =8;
	int olin0 =1;
	int opln0 =4;

	int ox1 []  = {-5,10,10,5,5,0,0,-5};
	int oy1 []  = {15,15,10,10,-10,-10,10,10};
	int oz1 []  = {0,0,0,0,0,0,0,0};
	int oln1 [] = {0,1,3};
	int opl1 [] = {0,1,2,3,4,5,6,7,0,-1};
	int osf1 [] = {0};
	int opon1 =8;
	int olin1 =1;
	int opln1 =1;

	int ox2 []  = {-5,10,10,0,0,5,5,0,0,10,10,-5};
	int oy2 []  = {15,15,10,10,5,5,0,0,-5,-5,-10,-10};
	int oz2 []  = {0,0,0,0,0,0,0,0,0,0,0,0};
	int oln2 [] = {0,1,3};
	int opl2 [] = {0,1,2,3,4,5,6,7,8,9,10,11,0,-1};
	int osf2 [] = {0};
	int opon2 =12;
	int olin2 =1;
	int opln2 =1;

	int ox3 []  = {-5,5,10,10,5,10,5,0,0,-5,0,3,5,5,3,0};
	int oy3 []  = {15,15,10,5,0,-10,-10,0,-10,-10,10,10,8,6,5,5};
	int oz3 []  = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	int oln3 [] = {0,1,3};
	int opl3 [] = {0,1,2,3,4,5,6,7,8,9,0,-1, 10,11,12,13,14,15,10,-9};
	int osf3 [] = {0,12};
	int opon3 =16;
	int olin3 =1;
	int opln3 =2;

	int ox4 []  = {-5,10,10,5,5,10,10,-5,-5,0,0,-5};
	int oy4 []  = {15,15,10,10,-5,-5,-10,-10,-5,-5,10,10};
	int oz4 []  = {0,0,0,0,0,0,0,0,0,0,0,0};
	int oln4 [] = {0,1,3};
	int opl4 [] = {0,1,2,3,4,5,6,7,8,9,10,11,0,-1};
	int osf4 [] = {0};
	int opon4 =12;
	int olin4 =1;
	int opln4 =1;

	int ox5 []  = {-5,10,10,0,0,10,10,-5,-5,5,5,-5};
	int oy5 []  = {15,15,10,10,5,5,-10,-10,-5,-5,0,0};
	int oz5 []  = {0,0,0,0,0,0,0,0,0,0,0,0};
	int oln5 [] = {0,1,3};
	int opl5 [] = {0,1,2,3,4,5,6,7,8,9,10,11,0,-1};
	int osf5 [] = {0,6,12,18,24,30};
	int opon5 =12;
	int olin5 =1;
	int opln5 =1;

	int ox6 []  = {0,5,10,5,4,1,0,-5,2,2,3};
	int oy6 []  = {15,15,-10,-10,-5,-5,-10,-10,0,5,0};
	int oz6 []  = {0,0,0,0,0,0,0,0,0,0,0,0};
	int oln6 [] = {0,1,3};
	int opl6 [] = {0,1,2,3,4,5,6,7,0,-1, 8,9,10,8,-9};
	int osf6 [] = {0};
	int opon6 =11;
	int olin6 =1;
	int opln6 =2;

	int ox7 []  = {-15,15,15,-15, 15,15,-15,-15};
	int oy7 []  = {-5,-5,5,5, 5,-5,5,-5};
	int oz7 []  = {5,5,5,5,0,0,0,0};
	int oln7 [] = {0,1,3};
	int opl7 [] = {0,1,2,3,0,-9, 7,5,4,6,7,-1};
	int osf7 [] = {0,6,12,18,24,30};
	int opon7 =8;
	int olin7 =1;
	int opln7 =1;

	int ox8 []  = {-15,15,15,-15, 15,15,-15,-15};
	int oy8 []  = {-5,-5,5,5, 5,-5,5,-5};
	int oz8 []  = {5,5,5,5,0,0,0,0};
	int oln8 [] = {0,1,3};
	int opl8 [] = {0,1,2,3,0,-9, 7,5,4,6,7,-1};
	int osf8 [] = {0,6,12,18,24,30};
	int opon8 =8;
	int olin8 =1;
	int opln8 =1;

// Figures Data:   #0 - #8 standard
//
	int figtab0[]={0,0,0,0,0, 0,0,0,0,0, 1,1,1,1,1, 0,0,0,0,0, 0,0,0,0,0};
	int figsize0 =5;
	int figtab1[]={ 0,0,0, 1,1,1, 0,0,0 };
	int figsize1 =3;
	int figtab2[]={ 0,0,0, 1,1,1, 0,1,0 };
	int figsize2 =3;
	int figtab3[]={ 0,0,0, 1,1,1, 0,0,1 };
	int figsize3 =3;
	int figtab4[]={ 0,0,0, 1,1,1, 1,0,0 };
	int figsize4 =3;
	int figtab5[]={ 0,0,0, 1,1,0, 0,1,1 };
	int figsize5 =3;
	int figtab6[]={ 0,0,0, 0,1,1, 1,1,0 };
	int figsize6 =3;
	int figtab7[]={ 1,1, 1,1 };
	int figsize7 =2;
	int figtab8[]={ 0,0,0, 1,1,1, 1,0,1 };
	int figsize8 =3;

// Extended figures: #9 - #11
	int figtab9[]={ 0,1,0, 0,1,0, 1,1,1 };
	int figsize9 =3;
	int figtab10[]={ 0,1,0, 1,1,1, 0,1,0 };
	int figsize10 =3;
	int figtab11[]={ 1,1,1, 0,1,0, 1,1,1 };
	int figsize11 =3;


//============================================================================
//	3D-GRAPHICS VARIABLES
//----------------------------------------------------------------------------

	int *ox;
	int *oy;
	int *oz;
	int *oln;
	int *opl;
	int *osf;
	float xpos	= 0;
	float ypos	= 0;
	float zpos	= 0;
	float xang	= 0;
	float yang	= 0;
	float zang	= 0;
	float mpos [9];
	float mobj [9];
	float matrxm [64];
	float matrym [64];
	float matrzm [64];
	int matrxp [64];
	int matryp [64];
	int polydata[32];

	int objects	= 0;
	int points	= 0;
	int lines	= 0;
	int polys	= 0;


//============================================================================
//	STAR FIELDS
//---------------------------------------------------------------------------
	int matrxs[512];
	int matrys[512];
	int matrzs[512];
	int matrss[512];
	float matrls[128];


//============================================================================
// Messages Data:
//---------------------------------------------------------------------------


	char *introtext[]= {
	"                EPISODE II",
	"          BATTLE FOR STAR TETRIS",
	" ",
	"It is a desperate time for planet Zoth and",
	"its people.  An alien race,  who call them",
	"selves Varions, dropped out of Outer Space",
	"and  has been  continuously  attacking the",
	"planet and its interiors.",
	" ",
	"An Imperial Task force lead by admiral Dor",
	"is enroute  to  Zoth  and  will  drive off",
	"alien insurgents and rescue the survivors.",
	"Until  then,  Zoth's  only  starport, STAR",
	"TETRIS, must be kept out of enemy hands in",
	"order for rescue operation to succeed.",
	" ",
	"Piloting WF-35 multirole space fighter you",
	"are to command a small group of volunteers",
	"and protect  STAR TETRIS fighting your way",
	"to freedom until help arrives.",
	"                      Good luck Commander!"
	};


	char *msg[]={
	" ",
	" ",
	" ",
	"Supernar Systems International ",
	"Presents ",
	"A Narech Koumar game ",
	"S T A R   T E T R I S   II ",
	"Directed by Narech Koumar ",
	"Designed and executed by Narech Koumar ",
	"Special Visual Effects by Narech Koumar ",
	"Music by REALITY TEAM and Narech Koumar ",
	"Produced by Narech Koumar   (C) SUNSYS 1995-1996, 1999 ",
	" ",
	" A LONG TIME AGO ",
	" IN THE GALAXY FAR AWAY... ",
// mesnum15
	" ",
	" ",
	" ",
	"Come on commander, press any key ",
	"DEMO MODE...   Press any key to start the game ",

	"Hey!  You didn't work hard,  did ya? ",
	"Type in your name, Commander ",
	"Good work, Commander ",
	"Well done, Commander ",
	"Excellent work, congratulations Commander ",
	" "," "," "," "," ",

// mesnum30
	"Come on commander, let's go and get them! ",
	"Don't let him go! ",
	"Switch on the light-speed, commander! ",
	"Watch it commander! ",
	"Don't miss him, commander! ",
	"The only way out is through, commander! ",
	"Come on and fight, commander! ",
	"Come on commander! ",
	"Don't give up commander! ",
	" ",

// mesnum40
	"Level one:   Battle for STAR TETRIS ",
	"Level two:   Green Sector Seven ",
	"Level three:   Road to the Sky ",
	"Level four:   Ocean of Souls ",
	"Level five:   Back to the Stars ",
	"Level six ",
	"Level seven ",
	"Level eight ",
	"Level nine ",
	"Level ten ",

// mesnum50
	"You got him commander! ",
	"Not bad commander! ",
	"You can do it! ",
	"Check it out! ",
	"Look, there's another one! ",
	"Target destroyed, commander! ",
	"He won't bother us any more! ",
	"Well done! ",
	"Very well done! ",
	"Nice! ",

// mesnum60
	"Good! ",
	"Nice shot, commander! ",
	"Good shooting, commander! ",
	"Just in time! ",
	"Impressive! ",
	"Very impressive! ",
	"Very good! ",
	"Good shot! Feels better now? ",
	" ",
	"Excellent! ",

// mesnum70
	" "," "," "," "," "," "," "," "," "," ",
	" "," "," "," "," "," "," "," "," "," ",
	" "," "," "," "," "," "," "," "," "," ",

// mesnum100
	" "
	};



//============================================================================
//	MESSAGE VARIABLES
//----------------------------------------------------------------------------

	char *amsg;
	int mesnum	= 0;
	int mesnumold	= -1;
	int prmes	= 1;
	int specmsg	= 0;
	int inprint	= 0;
	int inprintx	= 0;
	int inprintd	= 50;
	int inprinta	= 0;
	int inprintmax	= 50;
	int xps		= 0;
	int yps		= 0;



//============================================================================
//	GLASS TABLE
//----------------------------------------------------------------------------
	int figt[25];
	int scanl[25];
	int glass[512];
	int figtab[25];
	int figtabnext[25];
	int figsize	= 0;
	int figsizenext	= 0;
	int xfig	= 0;
	int yfig	= 0;
	int sfig	= 0;
	int sfig_easy	= 16;
	int scany	= 0;
	int fmov	= 0;
	int frot	= 0;
	int fdrop	= 0;
	int mdrop	= 0;
	int afig	= 0;
	int acol	= 0;
	int afignext	= 0;
	int acolnext	= 0;
	int lfig	= 0;
	int newfig	= 0;


	float scoretab[2048];
	unsigned char savebuf[2048];
	unsigned char imagebuf[64];
	char string_buffer[80];
	char message_string[80];
	char scsbuf[100];
	char *scoretable[]={
	" 1.                                            ",
	" 2.                                            ",
	" 3.                                            ",
	" 4.                                            ",
	" 5.                                            ",
	" 6.                                            ",
	" 7.                                            ",
	" 8.                                            ",
	" 9.                                            ",
	"10.                                            ",
	""
	};



//============================================================================
//	SYSTEM VARIABLES
//----------------------------------------------------------------------------

	int screen=0xA960;
	int sbport=0x0220;
	int sbvolume;
	int osbvolume;
	int oldsbvolume;
	int maxvolume=15;
	int musictab[16]={ 1, 2, 3, 4, 5, 1, 2, 3, 4, 5 , 1 ,2 ,3 ,4,0};
	int lfigtab[16]	={ 8, 9, 9,10,12,12,12,12,12,12 ,12,12,12,12,0};
	int sfigtab[16] ={16,14,12,10, 8, 6, 5, 4, 3, 2 , 1, 1, 1, 1,0}; 
	int leveltab[16]={ 1, 2, 3, 4, 5, 6, 7, 8, 9,10 ,10,10,10,10,0};
	int linestab[16]={ 0,40,50,40,40,30,50,50,50,50 ,90,90,90,90,0};
	int colortab[16]={15,11, 7, 9, 5, 6, 7,14, 3, 6 ,15,15,15,15,0}; 

	int colq=0;
	unsigned char colctab[16]={0, 1, 2, 3, 4, 5,20, 7,56,57,58,59,60,61,62,63};
	unsigned char colrtab[16]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char colgtab[16]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char colbtab[16]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char kolrtab[16]={0,12,24,36,30,60, 0, 0, 0, 0, 0, 0,30,60,58,60};
	unsigned char kolgtab[16]={0,12,24,36, 0, 0,30,60, 0, 0,30,60, 0, 0,58,60};
	unsigned char kolbtab[16]={0,12,24,36,30,60,30,60,30,60, 0, 0, 0, 0, 0,60};
	unsigned char pixtab[8]= { 0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01 };


//============================================================================
//	GAME VARIABLES
//----------------------------------------------------------------------------

	int level	= 1;
	int difficulty	= 1;
	int scorex	= 0;
	float score	= 0;
	int slines	= 0;
	int tlines	= 0;

	int speed	= 4;
	int tempc	= 0;
	int tempd	= 1;
	int tempn	= 0;

	int gameend	= 0;
	int maxstars	= 0;
	char cursor	= 32;
	int curpas	= 0;
	int net		= 0;
	int background	= 0;

	char key	= 0;
	char frkey	= 0;
	char flkey	= 0;
	char oldkey	= -1;
	int nokey	= 0;
	int color	= 0;

	int mouseis	=0;
	int mouseon	=0;
	int musicis	=0;
	int musicon	=0;
	int gamemode	=0;
	int gcorrect	=0;
	int framesync	=1;
	int radaron	=0;
	int shownext	=0;

	int	sw_nointro	= 0;
	int	sw_nomusic	= 0;
	int	sw_nomouse	= 0;
	int	sw_loadgame	= 0;
	int	sw_debug	= 0;
	int	sw_supervisor	= 0;

	unsigned int cpu_type = -1;
	unsigned char dos_bl = -1;
	unsigned char dos_ah = -1;
	unsigned char dos_al = -1;
	unsigned char run_al = -1;
	unsigned char tim_al = -1;
	unsigned char tim_ah = -1;
	int xmickey,ymickey,kmouse;
	int xmouse,ymouse,okmouse;
	int mesnumit;
	int demo;
	int lopez;
	int start_game;
	int timer_count=0;
	int maxtimer_count=4;
	unsigned char sfig_count=0;
	unsigned char g_count=0;
	unsigned char g_seconds=0;	// ingame time
	unsigned char g_minutes=0;
	unsigned char g_hours=0;

	unsigned char p_count=0;
	unsigned char p_seconds=0;	// inplay time
	unsigned char p_minutes=0;
	unsigned char p_hours=0;

//============================================================================





int mouseinit(void) {
asm {	xor ax,ax
	int 0x33
	test ax,ax
	jz nol1
	mov ax,0x0B
	int 0x33
	mov xmickey,cx
	mov ymickey,dx
	mov ax,0x03
	int 0x33
	mov kmouse,bx
	mov xmouse,cx
	mov ymouse,dx }
	return(0);
nol1:  	return(1);
}

int musicinit(void) {
asm {	mov al,1
	mov dx,sbport
	add dx,6
	out dx,al
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	mov al,0
	out dx,al
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	add dx,4
	mov cx,0x8000 }
l1: asm { in al,dx
	nop
	nop
	nop
	cmp al,0xAA
	je l2
	loop l1 }
	return(1);
l2:     return(0);
}

int setvolume(void) {
	int n;
	if (musicis==0) {
asm {	mov dx,sbport
	add dx,0x0004
	mov ax,0x0026
	out dx,al
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	mov dx,sbport
	add dx,0x0005
	in al,dx
	nop
	nop
	nop
	and ax,0x000F
	mov n,ax
	mov dx,sbport
	add dx,0x0004
	mov ax,0x0026
	out dx,al
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	mov dx,sbport
	add dx,0x0005
	mov ax,sbvolume
	shl ax,4
	or ax,sbvolume
	and ax,0x00FF
	out dx,al
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx
	in al,dx }
	return(n); }
	else return(0);
}

void volumedown(void)
{
	if (sbvolume>0)
	{
		sbvolume--;
		setvolume();
	}
}

void setmusic(unsigned int n)
{
	int i;
	if (musicis==0)
	{
		do setvolume(); while(--sbvolume >= 0); sbvolume++;
		asm mov ax,n;
		if(initplayer() != 0) loaderror();
		if(musicon==0) do setvolume(); while(++sbvolume <= maxvolume); sbvolume--;
	}
}



void setvariables()
{
	sw_nointro	= 0;
	sw_nomusic	= 0;
	sw_nomouse	= 0;
	sw_loadgame	= 0;
	sw_debug	= 0;
	sw_supervisor	= 0;

	mouseis		= 0;
	musicis		= 0;
	mouseon		= 0;    // on
	musicon		= 0;    // on
	gamemode	= 0;    // hard
	gcorrect	= 0;    // 0==normal
	framesync	= 1;	// off
	radaron 	= 0;
	net		= 0;
	key		= 0;
	oldkey		= -1;
	nokey		= 0;
	screen		= 0xA000;
	sbport		= 0x0220;

	cpu_type = -1;
	dos_bl = -1;
	dos_ah = -1;
	dos_al = -1;
	run_al = -1;
	xmickey= 0;
	ymickey= 0;
	kmouse= 0;
	xmouse= 0;
	ymouse= 0;
	okmouse=0;

}

int testhex(char n)
{
	asm {	mov al,n
		cmp al,0x30
		jb err
		cmp al,0x66
		ja err
		cmp al,0x39
		ja l1
		jmp l0 }
l1:	asm {	cmp al,0x41
		jb err
		cmp al,0x46
		ja l2
		jmp l0 }
l2:	asm {	cmp al,0x61
		jb err
		jmp l0 }
err:	printf("Invalid value %c\n");
	return(1);
l0:	return(0);
}


unsigned char hex(char n)
{
	unsigned char m;
	if (testhex(n)!=0) n='0';
	asm {	mov al,n
		cmp al,0x5A
		jb l0
		sub al,0x20 }
l0:	asm {	sub al,0x30
		cmp al,0x0A
		jb l1
		sub al,0x07 }
l1:     asm {	mov m,al }
	return(m);
}


int gethex(char *argv)
{
	unsigned int a1,a2,a3,a4;
	a1=hex(argv[6]); a2=hex(argv[7]); a3=hex(argv[8]); a4=hex(argv[9]);
	return(a1<<12|a2<<8|a3<<4|a4);
}

void check_adrive(char *argv)
{
	if (argv[0]=='A' || argv[0]=='a' || argv[0]=='B' || argv[0]=='b' )
	{
		printf("FATAL ERROR: \n");
		printf("Can not launch the game from drives A: or B:\n");
		printf("You must install the game onto your hard drive.\n");
		printf("To do so, type INSTALL at DOS prompt and follow\n");
		printf("the instructions on the screen.\n");
		exit(1);
	}
}

int getswitches(int argc, char *argv[]) {
	int x,y;
	int num=6;
	char *argstr[]={
		"-nointro",
		"-nomusic",
		"-nomouse",
		"-game",
		"-port ",
		"-debug",
		"-supervisor_mode" };
	int argdat[]={ 1,2,3,4,5,6,0 };

	check_adrive(argv[0]);
	if (argc<2) return(1);
	for (x=0; x<argc; x++) {
		for (y=0; y<num; y++)
		{
			if (strnicmp(argv[x],argstr[y],strlen(argstr[y]))==0)
			{
				switch(argdat[y])
				{
					case 0:	break;
					case 1:	sw_nointro=1;	break;
					case 2:	sw_nomusic=1;	break;
					case 3:	sw_nomouse=1;	break;
					case 4:	sw_loadgame=1;
						sw_nointro=1;
						break;
					case 5: sbport=gethex(argv[x]);
						break;
					case 6: sw_debug=1;	break;
				};
			}
		}
	}
	return(0);
}


//===========================================================================
// HERE IT GOES!!!
//---------------------------------------------------------------------------
void main(int argc, char *argv[]) {
	int n,m,i,c;

	start_game = 0;
	sfig_count=0;
	g_count=0;
	g_seconds=0;	// ingame time
	g_minutes=0;
	g_hours=0;

	p_count=0;
	p_seconds=0;	// inplay time
	p_minutes=0;
	p_hours=0;

	setvariables();
	getswitches(argc, argv);
	asm mov ax,0x03;
	asm int 0x10;
	systeminit();
	snslogo();
	_fmode = O_BINARY;

label0:	screenoff();
	setactivepage(0);
	cleardevice();
	setactivepage(1);
	initcolor();
	syncdisplay();
	screenon();

	if (sw_nointro==0)
	{
		setmusic(0x0081);
		intro();
	}

	screenoff();
	setactivepage(0);
	cleardevice();
	setactivepage(1);
	drawcockpit();
	initcolor();
	syncdisplay();
	screenon();

begin:	start_game = 0;
	initglass();
	setmusic(0x0082);
	if (demo!=0)
	{
		playdemo();
		if (demo!=0)
		{
			delay(300);
			goto label0;
		}
	}

	tlines	= 0;
	slines	= 0;
	score	= 0;
	level	= 1;
	difficulty=1;
	fmov	= 0;
	frot	= 0;
	fdrop	= 0;
	mdrop	= 0;
	scany	= 0;
	afig	= 0;
	acol	= 0;
	afignext= 0;
	acolnext= 0;
	newfig	= 0;
	xfig	= 5;
	yfig	= 0;
	sfig	= sfigtab[level-1];
	lfig	= 9;
	key	= 0;
	frkey	= 0;
	flkey	= 0;
	oldkey	= -1;
	kmouse	= 0;
	okmouse	= -1;
	nokey	= 0;
	net	= 0;
	speed	= 5;
	maxstars= 256;
	specmsg =0;
	mesnum 	= level+39;
	mesnumit=mesnum;
	inprintd= 60;
	inprintmax= 100;
	demo	 = 0;
	gameend	 = 0;
	background=0;

	if (enterlevel()!=0)
	{
		delay(100);
		syncdisplay();
		goto exittodos;
	}

	if (musicon==0) sbvolume=maxvolume;
	n=musictab[level-1];
	setmusic(n);

	if (start_game!=0) goto gameloop;

	specmsg = 0;
	mesnum 	= level+39;
	mesnumit= mesnum;
	inprintd= 100;
	inprintmax= 50;
	if (gamemode==0) sfig=sfigtab[level-1];
	else		 sfig=sfig_easy;
	clearscreen();
	drawstars();
	cockpit();
	syncdisplay();
	copyscreen();
	prlevel();
	prscore();
	prlines();
	afig	= random(9);
	acol	= (2+random(14))&0x0E;
	xfig	= 5;
	yfig	= 0;
	if (gamemode==0) sfig=sfigtab[level-1];
	else		 sfig=sfig_easy;
	lfig	= lfigtab[level-1];
	definefigure(afig);
	newfig	= 0;
	definenextfig();
	p_count =0;
	p_seconds=0;	// inplay time
	p_minutes=0;
	p_hours	=0;
	setcolor(15);

gameloop:
	do {
		clearscreen();		// clear screen
		drawstars();		// draw background

		plotfig();		// draw figure in tables
		plotglass();		// draw the glass on the screen
		radar();		// draw radar
		plotfig();		// erase figure

		shownextfig();
		setcolor(colortab[level-1]);
		printmessage(mesnum);	// print message
		if(framesync==0) syncdisplay();
		copyscreen();		// switch to visible screen

		moving();		// move the figure, draw if on bottom
		scanline();		// scan for lines

		if(newfig!=0)
		{
			definefig();
			definenextfig();
			if (testfig()!=0) goto gameover;
		}
		if(specmsg!=0)
		{
			specmsg=0;
			inprinta=0;
			mesnum=mesnumit;
		}
		else if(inprinta==0)
		{
			if((rand()&0x3F)==0) mesnum=30+random(9);
		} else mesnum=0;
	} while(key!=1);

gameover:
	c=4;
	key=0;
	inprinta=0;
	delay(100);
	do {
		clearscreen();
		drawstars();
		plotglass();
		setcolor(c);
		settextstyle(1,0,0);
		outtextxy(242,142,"GAME OVER");
		setcolor(c+1);
		outtextxy(240,140,"GAME OVER");
		if (c<15) c+=2; else c=4;
		setcolor(15);
		settextstyle(0,0,0);
		printmessage(0);
		shownextfig();
		copyscreen();
		if((mouseis|mouseon)==0)
		{
			asm {
			mov ax,0x03
			int 0x33
			mov kmouse,bx }
		}
	} while ((key|kmouse)==0);
	i=loadscore();
	if (i!=1) goto begin;
exittodos:
	inprinta=0;
	delay(200);
	do {
		clearscreen();
		drawstars();
		settextstyle(1,0,0);
		setcolour(2);
		print(221,151,"Exit to DOS");
		print(249,191,"(yes/no)");
		setcolour(14);
		print(220,150,"Exit to DOS");
		print(248,190,"(yes/no)");
		setcolour(15);
		settextstyle(0,0,0);
		printmessage(0);
		copyscreen();
		if((mouseis|mouseon)==0)
		{
			asm {
			mov ax,0x0B
			int 0x33
			mov xmickey,cx
			mov ymickey,dx
			mov ax,0x03
			int 0x33
			mov kmouse,bx }
		}
		n=key;
	} while ((n|kmouse)==0);
	if((n!=0x15) && (n!=0x1C) && (kmouse!=1))
	{
		delay(300);
		goto begin;
	}
	for (n=0; n<32; n++)
	{
		clearscreen();
		drawstars();
		settextstyle(1,0,0);
		setcolour(2);
		print(221,151," Good Bye...");
		setcolour(14);
		print(220,150," Good Bye...");
		setcolour(15);
		settextstyle(0,0,0);
		printmessage(0);
		copyscreen();
		fadein(); fadein();
		if ((n&0x02)==0x02) volumedown();
	}
	settextstyle(0,0,0);
	delay(100);
	sbvolume=0;
	setvolume();
	resetplayer();
	sbvolume=oldsbvolume;
	setvolume();
	_dos_setvect(8,timeint);
	_dos_setvect(9,biosint);
	asm {
	push ax
	mov al,36h
	out 43h,al
	xor al,al
	out 40h,al
	out 40h,al
	pop ax }
	setactivepage(0);
	cleardevice();
	screenoff();
	closegraph();
	screenoff();
	delay(500);

	st2logo();
	printf("\n");
	printf("               Copyright (C) Supernar Systems, Intl. 1995-1999\n");
	printf("                            Created by Narech Koumar\n\n");

	syncdisplay();
	screenon();
	delay(100);
	exit(0);
}


//----------------------------------------------------------------------------
void playdemo(void) {
	int c,i,n,m,handle;
	key	= 0;
	kmouse	= 0;
	mesnum	= 19;
	tlines	= 0;
	slines	= 0;
	score	= 0;
	level	= 1+random(5);
	scany	= 0;
	fmov	= 0;
	frot	= 0;
	fdrop	= 0;
	mdrop	= 0;
	key	= 0;
	kmouse	= 0;
	nokey	= 0;
	net	= 0;
	inprinta= 0;
	mesnum	=19;
	makelevel();
	clearscreen();
	copyscreen();
	prlevel();
	prscore();
	xfig	=5;
	yfig	=0;
	afig	=random(9);
	acol	=(2+random(14))&0x0E;
	lfig	= lfigtab[level-1];
	definefigure(afig);
	definenextfig();
	newfig	=0;
	if (gamemode==0) sfig=sfigtab[level-1]; else sfig=sfig_easy;
	do {	clearscreen();
		drawstars();
		plotfig();
		plotglass();
		cockpit();
		plotfig();
		shownextfig();
		copyscreen();
		demomoving();
		if (newfig!=0) {
			definefig();
			definenextfig();
			if (testfig()!=0) { delay(200); goto demoovr2; }
		}
		if (gameend!=0) goto demoover;
		if (inprinta==0) mesnum=19;
		if ((mouseis|mouseon)==0) {
		  asm { mov ax,0x0B
			int 0x33
			mov xmickey,cx
			mov ymickey,dx
			mov ax,0x03
			int 0x33
			mov kmouse,bx } }
	} while((key|kmouse)==0);
demoovr0:
	demo=0;
	goto demoover;
demoovr2:
	c=4;
	key	= 0;
	kmouse	= 0;
	mesnum	= 19;
	mesnumit= 19;
	inprinta= 0;
	inprintd= 60;
	inprintmax= 100;
	for (i=0; i<100; i++) {
		clearscreen();
		drawstars();
		setcolour(15);
		settextstyle(0,0,0);
		printmessage(19);
		plotglass();
		settextstyle(1,0,0);
		setcolour(c);outtextxy(242,142,"GAME OVER");
		setcolour(c+1);outtextxy(240,140,"GAME OVER");
		if (c<15) c+=2; else c=4;
		shownextfig();
		copyscreen();
		if ((mouseis|mouseon)==0) {
		  asm { mov ax,0x0B
			int 0x33
			mov xmickey,cx
			mov ymickey,dx
			mov ax,0x03
			int 0x33
			mov kmouse,bx } }
		if (key!=0) goto demoovr0;
		if (kmouse!=0) goto demoovr0;
	}
	settextstyle(0,0,0);
	if ( (handle=open(scorefile,O_RDWR | O_BINARY))==-1 ) scoreerror();
	if ( read(handle,scoretab,1024)==-1 ) scoreerror();
	if ( close(handle)==-1 ) scoreerror();
	initscoretab();
	inprinta=0;
	inprintd=50;
	key	= 0;
	kmouse	= 0;
	for (i=0; i<100; i++) {
		clearscreen();
		drawstars();
		plotglass();
		cockpit();
		shownextfig();
		prscoretab();
		copyscreen();
		if ((mouseis | mouseon)==0) {
		  asm { mov ax,0x0B
			int 0x33
			mov xmickey,cx
			mov ymickey,dx
			mov ax,0x03
			int 0x33
			mov kmouse,bx } }
		if (key!=0) goto demoovr0;
		if (kmouse!=0) goto demoovr0;
	}
	delay(300);
	demo	= 1;
	n=sbvolume;
	for(m=0; m<32; m++){ syncdisplay(); fadein(); fadein();
			if((m&0x02)==0x02) volumedown(); }
	sbvolume=n;
	clearscreen();
	copyscreen();
	syncdisplay();

demoover:
	delay(300);
	tlines	= 0;
	slines	= 0;
	score	= 0;
	level	= 1;
	scany	= 0;
	fmov	= 0;
	frot	= 0;
	fdrop	= 0;
	mdrop	= 0;
	key	= 0;
	kmouse	= 0;
	nokey	= 0;
	mesnum	= 30;
	mesnumit= 30;
	inprinta= 0;
	inprintd= 60;
	inprintmax= 100;
	gameend	= 0;
	initglass();
demoovrx:
	syncdisplay();
}

//----------------------------------------------------------------------------
void intro(void) {
	int n=0;
	int m=0;
	int s=0;
	unsigned char r=0;
	unsigned char g=0;
	unsigned char b=20;
	int ib=0;
	int show=1;
	int ob[12]={ 1,2,1,3,4,5, 5,1,6,3, 4,4 };
	int oc[12]={ 9,9,9,9,9,9, 9,9,9,9, 9,9};
	float xp[12]={ 50,30,10,-10,-30,-50, 30,10,-10,-30, 9,-9};
	float yp[12]={ 0,0,0,0,0,0, -5,-5,-5,-5, -32,-32};
	float zp[12]={ -2800,-2800,-2800,-2800,-2800,-2800, -50,-50,-50,-50, -400,-400};
	float xa[12]={ 0,0,0,0,0,0, 1,1,1,1, P2I,P2I};
	float ya[12]={ P2I,P2I,P2I,P2I,P2I,P2I, PI,PI,PI,PI, PI,PI};
	float za[12]={ 0,0,0,0,0,0, 0,0,0,0, 0,0};
	key		= 0;
	mesnum		= 0;
	inprinta	= 0;
	inprintd	= 70;
	inprintmax	= 80;
	maxstars	= 500;
	objects		= 6;
	speed		= 4;

	makestars();
	initcolor();
	screen=0xA960;
	setactivepage(1);
	do {    clearscreen();
		drawstars();
		if (s==0) show=1;
		if (s==6) show=2;
		if (s==7) show=3;
		if (s==8) show=4;
		if (s==9) show=5;
		for (n=0; n<objects; n++) {
			defineobject(ob[n]);
			xpos=xp[n];
			ypos=yp[n];
			zpos=zp[n];
			xang=xa[n];
			yang=ya[n];
			zang=za[n];
			objrotation();
			fillobject(oc[n]);
		switch (show) {
		case 1: fadeout();
			if (zp[n]<-400) zp[n]+=5;
			else if (zp[n]<-300) zp[n]+=4;
			break;
		case 2: if (ya[m]<PI) ya[m]+=.025;
			else if (m<5) m++;
			break;
		case 3: maxstars=400;
			objects=10;
			if (n>5) if (zp[n]>-450) {
				zp[n]-=5;
				yp[n]+=.5;
				if (xa[n]>0) xa[n]-=.01;
				else xa[n]=0;
			} break;
		case 4: maxstars=300;
			objects=12;
			if (n>9) if (xa[n]>0) xa[n]-=.1;
			asm {
			 	mov dx,03c8h
				mov al,56
				out dx,al
				inc dx
				mov al,r
				and al,3fh
				out dx,al
				mov al,g
				and al,3fh
				out dx,al
				mov al,b
				and al,3fh
				out dx,al
				}
			if (ib==0) { if (b<63) b++; else ib=1; }
			else { if (b>0) { b--; r++; }
			   else { if (g<50) g++; if (r>50) r--; }
			} break;
		case 5: if (xa[n]<1) { xa[n]+=.05; ib=0; }
			else { zp[n]-=6;
			 if (ib<84) ib++;
			 else { ib=0; if (r!=0) { r--; g--; }
			 asm {
			 	mov dx,03c8h
				mov al,56
				out dx,al
				inc dx
				mov al,r
				and al,3fh
				out dx,al
				mov al,g
				and al,3fh
				out dx,al
				mov al,b
				and al,3fh
				out dx,al
			} } } break;
	} }
		setcolour(7);
		printmessage(s);
		if (inprinta==0) if (s<14) s++; else goto intro1;
		copyscreen();
		if ((mouseis | mouseon)==0) {
			asm {
				mov ax,0x0B
				int 0x33
				mov xmickey,cx
				mov ymickey,dx
				mov ax,0x03
				int 0x33
				mov kmouse,bx
			 }
		}
	} while ((key|kmouse)==0);
intro1:	clearscreen();
	drawstars();
	copyscreen();
	setrgb(56,0,0,30);
	setrgb(62,58,58,0);
	demo	= 0;
	maxstars= 200;
	yps	= 400;
	setcolour(14);
	do {    clearscreen();
		drawstars();
		for(n=0; n<21; n++) print(154,yps+n*24,introtext[n]);
		box(0,0,639,8,0);
		yps-=2;
		if(yps < -600) demo=1;
		copyscreen();
		if((mouseis | mouseon)==0)
		{
			asm {	mov ax,0x03
				int 0x33
				mov kmouse,bx }
		}
	} while ((key|kmouse|demo)==0);
	for(m=0; m<16; m++)
	{
		clearscreen();
		drawstars();
		for (n=0; n<21; n++) print(154,yps+n*24,introtext[n]);
		box(0,0,639,8,0);
		yps-=2;
		if(yps < -600) syncdisplay();
		copyscreen();
		fadein(); fadein(); fadein(); fadein();
		volumedown();
	}
	setactivepage(0);
	cleardevice();
	initcolor();
}


void putmouse(void) {
	setcolor(15);
	if (mouseis==0) {
	mouseon=mouseon^1;
	setactivepage(0); screen=0xA000;
	if (mouseon==0) { box(207,383,235,397,2); print(214,386,"on"); }
	else { box(207,383,235,397,2); print(210,386,"off"); }
	setactivepage(1); screen=0xA960;
} }

void setradar(void) {
	int x,y;
	if (radaron==0) { radaron=1;
	syncdisplay();
	box(290,380,390,460,0);
	setcolour(6); print(310,413,"DISABLED");
	setcolour(7); print(309,412,"DISABLED");
	colour(1); linex(290,380,390,380); linex(290,380,290,460);
	colour(3); linex(290,460,390,460); linex(390,380,390,460);
	colour(10);for (y=390; y<460; y+=10) linex(291,y,389,y);
	colour(10);for (x=300; x<390; x+=10) linex(x,381,x,459); }
	else if (radaron==1) { radaron=0;
	syncdisplay();
	box(290,380,390,460,0);
	colour(1); linex(290,380,390,380); linex(290,380,290,460);
	colour(3); linex(290,460,390,460); linex(390,380,390,460);
	colour(10);for (y=390; y<460; y+=10) linex(291,y,389,y);
	colour(10);for (x=300; x<390; x+=10) linex(x,381,x,459); }
	plotfig();
	radar();
	plotfig(); }


void setbackground(void) {
	if (background==0) background=1;
	else if (background==1) background=0; }

void putmusic(void) {
	setcolor(15);
	if (musicis==0) {
	musicon=musicon^1;
	setactivepage(0); screen=0xA000;
	if (musicon==0) {
	 box(251,383,279,397,2);
	 print(258,386,"on");
	 sbvolume=maxvolume;
	 osbvolume=setvolume(); }
	else {
	 box(251,383,279,397,2);
	 print(254,386,"off");
	 sbvolume=0;
	 osbvolume=setvolume(); }
	setactivepage(1); screen=0xA960;
} }

void putmode(void) {
	setcolor(15);
	gamemode=gamemode^1;
	setactivepage(0); screen=0xA000;
	if (gamemode==0) {
	box(410,372,444,394,2);
	setcolour(15); print(410,374,"MODE");
	setcolour(15); print(410,386,"HARD"); }
	else {
	box(410,372,444,394,2);
	setcolour(15); print(410,374,"MODE");
	setcolour(15); print(410,386,"EASY"); }
	setactivepage(1); screen=0xA960;
}

void moving(void) {
	int n,m;
	if ((mouseis | mouseon)==0) {
	  asm { mov ax,0x0B
		int 0x33
		mov xmickey,cx
		mov ymickey,dx
		mov ax,0x03
		int 0x33
		mov kmouse,bx
		mov xmouse,cx
		mov ymouse,dx }
		if (xmickey>8) right();
		if (xmickey>200) right();
		if (xmickey>300) right();
		if (xmickey<-8) left();
		if (xmickey<-200) left();
		if (xmickey<-300) left();
	}

	if (oldkey==key) flkey++; else flkey=0;
	if (nokey>0) nokey--;
	if (nokey==0) {
	   if ((mouseis | mouseon)==0) {
	   if (kmouse==1) { nokey=1; figrotate(); }
	   if (kmouse==2) { nokey=1; fdrop=1; mdrop=yfig; } }

	   switch (key) {
		case 57:	fdrop=1; mdrop=yfig; break;
		case 80:	fdrop=1; mdrop=yfig; break;
		case 77:	if (flkey<1 || flkey>2) right();  break;
		case 75:	if (flkey<1 || flkey>2) left();   break;
		case 72:	figrotate(); break;

		case 0x3B:	nokey=3; putmouse(); break;
		case 0x3C:      nokey=3; putmusic(); break;
		case 0x3D:	nokey=3; putmode(); break;
		case 0x3E:	nokey=3; net=net^1; break;
		case 0x3F:	nokey=3; loadgame(); break;
		case 0x40:	nokey=3; savegame(); break;

		case 0x41:	nokey=3; bosspage(); break;
		case 0x42:	nokey=3; bosspage(); break;

		case 0x43:      nokey=3; setbackground(); break;
		case 0x44:      nokey=3; helppage(); break;
		case 0x57:      nokey=3; gammacorrect(); break;
		case 0x58:	nokey=3; mainmenu(); break;

		case 45:	pause(); break;
		case 46:	pause(); break;
		case 25:	pause(); break;
	 } }
// figure falling at level's speed
	if (fdrop==0) {
		if (sfig<=0) {
			if (gamemode==0) sfig=sfigtab[level-1]; else sfig=sfig_easy;
			yfig+=1;
			if (testfig()!=0) {
				yfig-=1;
				newfig=1;
				plotfig();
				score+= 5*( (difficulty*3) + (level*2) + afig + acol);
				mdrop=0;
				prscore();
		} }
	}
// key down is pressed. free fall
	else {  yfig+=1;
		if (testfig()!=0) {
			yfig-=1;
			newfig=1;
			plotfig();
			fdrop=0;
			score+= 5* ( (difficulty*3) + (level*2) + afig + acol + (24-mdrop)/2);
			mdrop=0;
			prscore();
	} }
	oldkey=key;
	okmouse=kmouse;
}


void demomoving(void) {
	int n,m;
	if ((mouseis | mouseon)==0) {
	  asm { mov ax,0x0B
		int 0x33
		mov xmickey,cx
		mov ymickey,dx
		mov ax,0x03
		int 0x33
		mov kmouse,bx } }
	n=random(30);
	switch (n) {
	case 0:		fdrop=1; break;

	case 1:         break;
	case 3:         right(); break;
	case 5:         right(); break;
	case 7:         right(); break;
	case 9:         break;

	case 2:         break;
	case 4:         left(); break;
	case 6:         left(); break;
	case 8:         left(); break;
	case 10:        break;

	case 11:        oldkey^=1; break;
	case 13:        oldkey^=1; break;
	case 15:        oldkey^=1; figrotate(); break;
	case 18:	oldkey^=1; figrotate(); break;
	}
	if (fdrop==0) {
		if (sfig<=0) {
			if (gamemode==0) sfig=sfigtab[level-1]; else sfig=sfig_easy;
			yfig+=1;
			if (testfig()!=0) {
				yfig-=1;
				newfig=1;
				plotfig();
				score+=5*(level*afig+acol);
				prscore();
				setcolor(15);
		} }
	}
	else {
		yfig+=1;
		if (testfig()!=0) {
			yfig-=1;
			newfig=1;
			plotfig();
			fdrop=0;
			m=(24-yfig)/4;
			score+=5*(level*afig+acol+m);
			prscore();
			setcolor(15);
	} }
	scanline();
	oldkey=key;
	okmouse=kmouse;
}



void right() {
	xfig+=1;
	if (testfig()!=0) xfig-=1; }

void left() {
	xfig-=1;
	if (testfig()!=0) xfig+=1; }

void plotglass() {
	int *b;
	int x,y,xd,yd,xd2,yd2;
	box (230,10,240,310,4);
	box (230,310,420,320,4);
	box (410,320,420,10,4);
	asm mov ax,10
	asm mov bx,230
	asm mov cx,3
	asm mov dx,321
	vline();
	asm mov ax,10
	asm mov bx,240
	asm mov cx,2
	asm mov dx,311
	vline();
	asm mov ax,10
	asm mov bx,410
	asm mov cx,3
	asm mov dx,310
	vline();
	asm mov ax,10
	asm mov bx,420
	asm mov cx,2
	asm mov dx,320
	vline();
	asm mov ax,230
	asm mov bx,10
	asm mov cx,3
	asm mov dx,239
	hline();
	asm mov ax,410
	asm mov bx,10
	asm mov cx,3
	asm mov dx,419
	hline();
	asm mov ax,241
	asm mov bx,310
	asm mov cx,3
	asm mov dx,410
	hline();
	asm mov ax,231
	asm mov bx,320
	asm mov cx,2
	asm mov dx,420
	hline();
	if (net==0) {
		colour(1);
		for (x=241; x<410; x+=12) {
			asm mov ax,10;
			asm mov bx,x;
			asm mov cx,1;
			asm mov dx,309;
			vline(); }
		for (y=22; y<310; y+=12) {
			asm mov ax,241
			asm mov bx,y
			asm mov cx,1
			asm mov dx,409
			hline(); } }
	for (y=0; y<25; y++) {
		for (x=1; x<15; x++) {
			b=(glass+(x+(y*16)));
			xd=x*12+230;
			xd2=xd+10;
			yd=y*12+11;
			yd2=yd+10;
			if (*b!=0) {
				box(xd,yd,xd2,yd2,*b);
				asm mov ax,xd;
				asm mov bx,yd;
				asm mov cx,3
				asm mov dx,xd2;
				hline();
				asm mov ax,xd;
				asm mov bx,yd2;
				asm mov cx,2;
				asm mov dx,xd2;
				hline();
				asm mov ax,yd;
				asm mov bx,xd;
				asm mov cx,3;
				asm mov dx,yd2;
				vline();
				asm mov ax,yd;
				asm mov bx,xd2;
				asm mov cx,2;
				asm mov dx,yd2;
				vline(); }
} } }

void plotfig() {
	int x=0;
	int y=0;
	int n=0;
	for (y=0; y<figsize; y++)
	 for (x=0; x<figsize; x++) {
	  if (figtab[n]!=0) *(glass+((x+xfig)+(y+yfig)*16))^=(figtab[n]+acol);
	  n++; }
}


int testfig() {
	int x=0;
	int y=0;
	int n=0;
	for (y=0; y<figsize; y++)
	 for (x=0; x<figsize; x++) {
	  if ( (*(glass+x+xfig+(y+yfig)*16)!=0) && (figtab[n]!=0) ) return(1);
	  n++;
	 }
return(0);
}

int testrotfig() {
	int *b;
	int x=0;
	int y=0;
	int n=0;
	for (y=0; y<figsize; y++)
	 for (x=0; x<figsize; x++) {
	  if ( (*(glass+x+xfig+(y+yfig)*16)!=0) && (figt[n]!=0) ) return(1);
	  n++;
	}
return(0);
}

void figrotate() {
	int b;
	int x,y;
	int yy;
	int xx=0;
	if ((key!=oldkey) || (kmouse!=okmouse)) {
	for (y=0; y<figsize; y++) {
		yy=figsize-1;
		for (x=0; x<figsize; x++) {
			figt[(xx+yy*figsize)]=figtab[(x+y*figsize)];
			yy--; }
	xx++; }
	if (testrotfig()==0) {
		frot=2;
		for (y=0; y<figsize; y++) {
			for (x=0; x<figsize; x++) {
				b=(x+y*figsize);
				figtab[b]=figt[b];
			}
} } } }

void scanline() {
	int n;
	int scanx;
	int x,y;
	int yc;
	for (y=0; y!=25; y++) {
	scanx=0;
		for (x=1; x!=15; x++) if ( *(glass+x+y*16)!=0 ) scanx++;
		if ((scanx==14) && (scanl[y]==0)) {
				scanl[y]=10;		// times to flash
				scany++;
				tlines++;
				slines++;
				score+=50+(difficulty*5);
				prlines();
				prscore();
				setcolor(15);
				mesnumit=50+random(20);
				specmsg=1; }
	}
	if (scany>0) for (y=0; y!=25; y++) {
		if (scanl[y]>1) { 
			for (x=1; x!=15; x++) *(glass+x+y*16)^=1;
			scanl[y]--; }
		if (scanl[y]==1) {
			for (yc=(y*16)-1; yc>0; yc--) *(glass+yc+16)=*(glass+yc);
			scanl[y]=0;
			scany--; }
	}
}


void cockpit() {
	setcolour(15);
	if (prmes!=0) printmessage(mesnum);
	radar();
}

void radar() {
	int c;
	int *b;
	int x,y,xd,yd;
	if (radaron==0) {
	screen=0xA000;
	for (y=0; y<26; y++) {
		for (x=0; x<16; x++) {
			b=(glass+(x+(y*16)));
			c=*b;
			xd=x*2+324;
			yd=y*2+394;
			asm mov ax,xd;
			asm mov bx,yd;
			asm mov cx,c;
			plot();
			asm mov ax,xd;
			asm mov bx,yd;
			asm mov cx,c;
			asm inc ax;
			plot();
			asm mov ax,xd;
			asm mov bx,yd;
			asm mov cx,c;
			asm inc ax;
			asm inc bx;
			plot();
			asm mov ax,xd;
			asm mov bx,yd;
			asm mov cx,c;
			asm inc bx;
			plot();
	} }
	screen=0xA960;
} }

void shownextfig() {
	int x,y,xd,yd,xd2,yd2;
	if (shownext==0) {
		asm mov ax,120;
		asm mov bx,80-1;
		asm mov cx,3
		asm mov dx,180;
		hline();
		asm mov ax,120;
		asm mov bx,140+1;
		asm mov cx,2;
		asm mov dx,180;
		hline();
		asm mov ax,80;
		asm mov bx,120-1;
		asm mov cx,3;
		asm mov dx,140+1;
		vline();
		asm mov ax,80;
		asm mov bx,180+1;
		asm mov cx,2;
		asm mov dx,140+1;
		vline();
		for (x=120; x<=180; x+=12) {
			asm mov ax,80;
			asm mov bx,x;
			asm mov cx,1;
			asm mov dx,140;
			vline(); }
		for (y=80; y<=140; y+=12) {
			asm mov ax,120
			asm mov bx,y
			asm mov cx,1
			asm mov dx,180
			hline(); }
		for (y=0; y<5; y++) {
		  for (x=0; x<5; x++) {
			xd=x*12+120+1;
			xd2=xd+10;
			yd=y*12+80;
			yd2=yd+10;
			if (figtabnext[x+y*5]!=0) {
				box(xd,yd,xd2,yd2,acolnext+1);
				asm mov ax,xd;
				asm mov bx,yd;
				asm mov cx,3
				asm mov dx,xd2;
				hline();
				asm mov ax,xd;
				asm mov bx,yd2;
				asm mov cx,2;
				asm mov dx,xd2;
				hline();
				asm mov ax,yd;
				asm mov bx,xd;
				asm mov cx,3;
				asm mov dx,yd2;
				vline();
				asm mov ax,yd;
				asm mov bx,xd2;
				asm mov cx,2;
				asm mov dx,yd2;
				vline(); }
		  }
		}
	}
}

void definefig() {
	xfig	= 5;
	yfig	= 0;
	afig	= afignext;
	acol	= acolnext;
	if (gamemode==0) sfig=sfigtab[level-1]; else sfig=sfig_easy;
	definefigure(afig);
	newfig	= 0;
}

void definenextfig() {
	afignext= random(lfig);
	acolnext= (2+random(14))&0x0E;
	definenextfigure(afignext);
}





void objrotation(void) {
	int n;
	float sx,sy,sz,cx,cy,cz,x,y,z;
	sx=sin(xang);
	sy=sin(yang);
	sz=sin(zang);
	cx=cos(xang);
	cy=cos(yang);
	cz=cos(zang);
	mobj[0]= cz*cy+sz*sx*sy;
	mobj[1]= sz*cx;
	mobj[2]= sz*sx*cy-cz*sy;
	mobj[3]= cz*sx*sy-sz*cy;
	mobj[4]= cz*cx;
	mobj[5]= sz*sy+cz*sx*cy;
	mobj[6]= cx*sy;
	mobj[7]= -sx;
	mobj[8]= cx*cy;
	for (n=0; n<points; n++) {
		matrxm[n] = mobj[0]*ox[n]+mobj[1]*oy[n]+mobj[2]*oz[n]+xpos;
		matrym[n] = mobj[3]*ox[n]+mobj[4]*oy[n]+mobj[5]*oz[n]+ypos;
		matrzm[n] = mobj[6]*ox[n]+mobj[7]*oy[n]+mobj[8]*oz[n]+zpos;
		if (matrzm[n]!=0) {
		matrxp[n]=xorigo+matrxm[n]*1024/matrzm[n];
		matryp[n]=yorigo+matrym[n]*1024/matrzm[n];
		}
	}
}

void drawobject(void) {
	int n,m;
	int x1,y1,x2,y2;
	for (n=0; n<(lines*3); n++) {
		x1=matrxp[oln[n]];
		y1=matryp[oln[n]];
		x2=matrxp[oln[n+1]];
		y2=matryp[oln[n+1]];
		n+=2;
		colour(oln[n]);
		linex(x1,y1,x2,y2); } }

void fillobject(int c) {
	int *i;
	int n,j,p;
	for (p=0; p<polys; p++) {
		i=&opl[osf[p]];
		j=0;
		n=0;
		while( *i>=0 ) {
			polydata[j]=matrxp[*i];
			polydata[j+1]=matryp[*i];
			i++;
			n++;
			j+=2;
		}
		setcolour(*i+c);
		setfillstyle(1,*i+c);
		fillpoly(n,polydata);
} }

void plot() {
asm	{
	push es
	mov si,ax
	mov di,bx
	mov bx,cx
	shl di,1
	mov cx,di
	shl di,2
	add di,cx
	shl di,3
	mov cx,si
	shr si,3
	add di,si
	and cl,7
	mov ch,0x80
	ror ch,cl
	mov es,screen
	mov dx,0x03ce
	mov ax,0x0205
	out dx,ax
	mov al,0x08
	mov ah,ch
	out dx,ax
	mov al,es:[di]
	mov es:[di],bl
	mov ax,0x0005
	out dx,ax
	mov ax,0xff08
	out dx,ax
	pop es
} }

void plop() {
asm	{
	push es
	mov dx,0x03ce
	mov ax,0x0205
	out dx,ax
	shl di,1
	mov bx,di
	mov cl,2
	shl di,cl
	add di,bx
	inc cl
	shl di,cl
	mov bx,si
	shr si,cl
	add di,si
	and bx,7
	mov ch,byte ptr pixtab[bx+0]
	mov es,screen
	mov cl,7
	sub cl,bl
	mov dx,0x03ce
	mov al,4
	mov ah,3
	mov ch,1
	shl ch,cl
	xor bl,bl
	}
l1: asm {
	out dx,ax
	mov bh,es:[di]
	and bh,ch
	shr bh,cl
	shl bl,1
	or bl,bh
	dec ah
	jnl l1
	mov ax,0x0005
	out dx,ax
	mov ax,0xff08
	out dx,ax
	mov al,bl
	xor ah,ah
	pop es
} }

void hline() {
asm	{
	push es
	cmp ax,dx
	jle l1
	xchg ax,dx }
l1: asm	{
	mov ch,cl
	mov si,ax
	mov di,dx
	shr si,3
	shr di,3
	sub di,si
	push di
	mov si,bx
	shl si,1
	mov di,si
	shl si,2
	add di,si
	shl di,3
	mov si,ax
	shr si,3
	add di,si
	and al,7
	mov cl,al
	mov bh,0xff
	shr bh,cl
	xor dl,0xff
	and dl,7
	mov cl,dl
	mov bl,0xff
	shl bl,cl
	mov es,screen
	mov dx,0x03ce
	mov ax,0x0205
	out dx,ax
	pop si
	or si,si
	jz l2
	cmp si,1
	jz l3
	dec si
	mov al,8
	mov ah,bh
	out dx,ax
	mov al,es:[di]
	mov es:[di],ch }
l4: asm	{
	inc di
	mov ax,0xff08
	out dx,ax
	mov al,es:[di]
	mov es:[di],ch
	dec si
	jnz l4
	inc di
	mov al,8
	mov ah,bl
	out dx,ax
	mov al,es:[di]
	mov es:[di],ch
	jmp le }
l2: asm	{
	and bh,bl
	mov al,8
	mov ah,bh
	out dx,ax
	mov al,es:[di]
	mov es:[di],ch
	jmp le }
l3: asm	{
	mov al,8
	mov ah,bh
	out dx,ax
	mov al,es:[di]
	mov es:[di],ch
	inc di
	mov al,8
	mov ah,bl
	out dx,ax
	mov al,es:[di]
	mov es:[di],ch }
le: asm	{
	mov ax,0x0005
	out dx,ax
	mov ax,0xff08
	out dx,ax
	pop es }
}

void vline() {
asm	{
	push es
	cmp ax,dx
	jle l1
	xchg ax,dx }
l1: asm	{
	mov si,bx
	mov di,ax
	sub dx,ax
	push dx
	mov bx,cx
	shl di,1
	mov cx,di
	shl di,2
	add di,cx
	shl di,3
	mov cx,si
	shr si,3
	add di,si
	and cl,7
	mov ch,0x80
	ror ch,cl
	mov es,screen
	mov dx,0x03ce
	mov ax,0x0205
	out dx,ax
	mov al,8
	mov ah,ch
	out dx,ax
	pop cx
	}
l2: asm {
	mov al,es:[di]
	mov es:[di],bl
	add di,0x50
	dec cx
	jnz l2
	mov ax,0x0005
	out dx,ax
	mov ax,0xff08
	out dx,ax
	pop es
	}
}



void box(int x1,int y1,int x2,int y2,int c) {
asm	{
	push es
	mov si,x1
	mov di,x2
	cmp si,di
	jle l1
	xchg si,di
	mov x1,si
	mov x2,di }
l1: asm	{
	mov si,y1
	mov di,y2
	cmp si,di
	jle l2
	xchg si,di
	mov y1,si
	mov y2,di }
l2: asm	{
	sub di,si
	mov ax,x1
	mov bx,si
	mov cx,c
	mov dx,x2
	push di
	mov ch,cl
	mov si,ax
	mov di,dx
	shr si,3
	shr di,3
	sub di,si
	push di
	mov si,bx
	shl si,1
	mov di,si
	shl si,2
	add di,si
	shl di,3
	mov si,ax
	shr si,3
	add di,si
	and al,7
	mov cl,al
	mov bh,0xff
	shr bh,cl
	xor dl,0xff
	and dl,7
	mov cl,dl
	mov bl,0xff
	shl bl,cl
	mov es,screen
	mov dx,0x03ce
	mov ax,0x0205
	out dx,ax
	pop si
	pop ax
	or si,si
	jz ll2
	cmp si,1
	jz ll1
	dec si }
ll0: asm {
	push ax
	push si
	push di
	mov al,8
	mov ah,bh
	out dx,ax
	mov al,es:[di]
	mov es:[di],ch
	mov ax,0xff08
	out dx,ax }
l4: asm	{
	inc di
	mov al,es:[di]
	mov es:[di],ch
	dec si
	jnz l4
	inc di
	mov al,8
	mov ah,bl
	out dx,ax
	mov al,es:[di]
	mov es:[di],ch
	pop di
	add di,80
	pop si
	pop ax
	dec ax
	jnz ll0
	jmp lle }
ll1: asm {
	push ax
	push si
	mov al,8
	mov ah,bh
	out dx,ax
	mov al,es:[di]
	mov es:[di],ch
	mov al,8
	mov ah,bl
	out dx,ax
	mov al,es:[di+1]
	mov es:[di+1],ch
	add di,80
	pop si
	pop ax
	dec ax
	jnz ll1
	jmp lle }
ll2: asm {
	push ax
	push si
	and bh,bl
	mov al,8
	mov ah,bh
	out dx,ax
	mov al,es:[di]
	mov es:[di],ch
	add di,80
	pop si
	pop ax
	dec ax
	jnz ll2 }
lle: asm {
	mov ax,0x0005
	out dx,ax
	mov ax,0xFF08
	out dx,ax
	pop es }
}


void copyscreen(void) {
asm {
	push ds
	push es
	pushad
	cld
	mov dx,0x03CE
	mov ax,0xFF08
	out dx,ax
	mov ax,0x0105
	out dx,ax
	mov dx,0x03C4
	mov ax,0x0F02
	out dx,ax
	mov ecx,0x6A00
	xor esi,esi
	xor edi,edi
	mov ax,0xA000
	mov es,ax
	mov ax,0xA960
	mov ds,ax
	rep movsb
	popad
	pop es
	pop ds
} }


void clearscreen(void) {
asm {	push ds
	push es
	pushad
	cld
	mov dx,0x03CE
	mov ax,0x0205
	out dx,ax
	mov ax,0xFF08
	out dx,ax
	mov ax,0xA960
	mov es,ax
	xor eax,eax
	xor edi,edi
	mov ecx,0x1A80
	rep stosd
	mov dx,0x03CE
	mov ax,0x0005
	out dx,ax
	popad
	pop es
	pop ds
} }

void colour (int col) {
	color = col; }

void setcolour (int col) {
	setcolor(col);
	color = col; }

void linex (int x1, int y1, int x2, int y2) {
	int i, deltax, deltay, numpixels;
	int d, dinc1, dinc2;
	int x, xinc1, xinc2;
	int y, yinc1, yinc2;
	deltax = abs(x2 - x1);
	deltay = abs(y2 - y1);
	if (deltax >= deltay) {
		numpixels = deltax + 1;
		d = (2 * deltay) - deltax;
		dinc1 = deltay << 1;
		dinc2 = (deltay - deltax) << 1;
		xinc1 = 1;
		xinc2 = 1;
		yinc1 = 0;
		yinc2 = 1; }
	else {	numpixels = deltay + 1;
		d = (2 * deltax) - deltay;
		dinc1 = deltax << 1;
		dinc2 = (deltax - deltay) << 1;
		xinc1 = 0;
		xinc2 = 1;
		yinc1 = 1;
		yinc2 = 1; }
	if (x1 > x2) {
		xinc1 = - xinc1;
		xinc2 = - xinc2; }
	if (y1 > y2) {
		yinc1 = - yinc1;
		yinc2 = - yinc2; }
	x = x1;
	y = y1;
	for (i=0; i<numpixels; i++) {
		asm mov ax,x
		asm mov bx,y
		asm mov cx,color
		plot();
		if (d < 0) {
			d = d + dinc1;
			x = x + xinc1;
			y = y + yinc1; }
		else {	d = d + dinc2;
			x = x + xinc2;
			y = y + yinc2; }
		}
	}




void interrupt timer() {
asm {
	inc g_count
	cmp g_count,91
	jb lg1
	mov g_count,0
	add g_seconds,5
	cmp g_seconds,60
	jb lg1
	mov g_seconds,0
	inc g_minutes
	cmp g_minutes,60
	jb lg1
	mov g_minutes,0
	inc g_hours }
lg1: asm {
	inc p_count
	cmp p_count,91
	jb lp1
	mov p_count,0
	add p_seconds,5
	cmp p_seconds,60
	jb lp1
	mov p_seconds,0
	inc p_minutes
	cmp p_minutes,60
	jb lp1
	mov p_minutes,0
	inc p_hours }
lp1: asm {
	mov ax,timer_count
	inc ax
	mov timer_count,ax
	cmp ax,maxtimer_count
	jb l0
	mov timer_count,0 }
l0:	if (sfig_count==0) asm dec sfig
	asm pushf
	asm call dword ptr timeint;
}




void interrupt inkey() {
asm {   in al,0x60
	cmp al,0xE0
	je k3
	test al,0x80
	je k1 }
k2: asm {
	mov key,0
	jmp k3 }
k1: asm mov key,al
k3: asm {
	mov al,0x20
	out 0x20,al }
}

void screenoff(void)
{ asm { mov dx,0x03c4
	mov al,1
	out dx,al
	inc dx
	in al,dx
	or al,0x20
	out dx,al } }

void screenon(void)
{ asm { mov dx,0x03c4
	mov al,1
	out dx,al
	inc dx
	in al,dx
	and al,0xdf
	out dx,al } }



void flashscreen() {
	int i,n;
	unsigned char r;
	unsigned char g;
	unsigned char b;
	for (n=0; n<64; n++) {
		syncdisplay();
		for (i=0; i<64; i++) {
			asm {	mov dx,0x03c7
				mov ax,i
				out dx,al
				mov dx,0x03c9
				in al,dx
				mov r,al
				in al,dx
				mov g,al
				in al,dx
				mov b,al }
				if(r<64) r++;
				if(g<64) g++;
				if(b<64) b++;
			asm { 	mov dx,0x03c8
				mov ax,i
				out dx,al
				mov dx,0x03c9
				mov al,r
				out dx,al
				mov al,g
				out dx,al
				mov al,b
				out dx,al } } }
initcolor(); }



void fadein(void) {
	int i,n;
	unsigned char r;
	unsigned char g;
	unsigned char b;
	for (i=0; i<256; i++) {
	asm { 	mov dx,03c7h
		mov ax,i
		out dx,al
		mov dx,03c9h
		in al,dx
		mov r,al
		in al,dx
		mov g,al
		in al,dx
		mov b,al }
	if(r>0) r--;
	if(g>0) g--;
	if(b>0) b--;
	asm { 	mov dx,03c8h
		mov ax,i
		out dx,al
		mov dx,03c9h
		mov al,r
		out dx,al
		mov al,g
		out dx,al
		mov al,b
		out dx,al }
} }

void fadeout(void) {
	unsigned char i,r,g,b;
	if (colq<4) colq++;
	else {
		colq=0;
		asm { 	mov dx,03c8h
			mov al,1
			out dx,al
			inc dx
			mov al,colrtab[1]
			out dx,al
			mov al,colgtab[1]
			out dx,al
			mov al,colbtab[1]
			out dx,al }
		if (colrtab[1]<kolrtab[1]) colrtab[1]++;
		if (colgtab[1]<kolgtab[1]) colgtab[1]++;
		if (colbtab[1]<kolbtab[1]) colbtab[1]++;
		asm { 	mov dx,03c8h
			mov al,2
			out dx,al
			inc dx
			mov al,colrtab[2]
			out dx,al
			mov al,colgtab[2]
			out dx,al
			mov al,colbtab[2]
			out dx,al }
		if (colrtab[2]<kolrtab[2]) colrtab[2]++;
		if (colgtab[2]<kolgtab[2]) colgtab[2]++;
		if (colbtab[2]<kolbtab[2]) colbtab[2]++;
		asm { 	mov dx,03c8h
			mov al,3
			out dx,al
			inc dx
			mov al,colrtab[3]
			out dx,al
			mov al,colgtab[3]
			out dx,al
			mov al,colbtab[3]
			out dx,al }
		if (colrtab[3]<kolrtab[3]) colrtab[3]++;
		if (colgtab[3]<kolgtab[3]) colgtab[3]++;
		if (colbtab[3]<kolbtab[3]) colbtab[3]++;
		asm { 	mov dx,03c8h
			mov al,4
			out dx,al
			inc dx
			mov al,colrtab[4]
			out dx,al
			mov al,colgtab[4]
			out dx,al
			mov al,colbtab[4]
			out dx,al }
		if (colrtab[4]<kolrtab[4]) colrtab[4]++;
		if (colgtab[4]<kolgtab[4]) colgtab[4]++;
		if (colbtab[4]<kolbtab[4]) colbtab[4]++;
		asm { 	mov dx,03c8h
			mov al,5
			out dx,al
			inc dx
			mov al,colrtab[5]
			out dx,al
			mov al,colgtab[5]
			out dx,al
			mov al,colbtab[5]
			out dx,al }
		if (colrtab[5]<kolrtab[5]) colrtab[5]++;
		if (colgtab[5]<kolgtab[5]) colgtab[5]++;
		if (colbtab[5]<kolbtab[5]) colbtab[5]++;
		asm { 	mov dx,03c8h
			mov al,20
			out dx,al
			inc dx
			mov al,colrtab[6]
			out dx,al
			mov al,colgtab[6]
			out dx,al
			mov al,colbtab[6]
			out dx,al }
		if (colrtab[6]<kolrtab[6]) colrtab[6]++;
		if (colgtab[6]<kolgtab[6]) colgtab[6]++;
		if (colbtab[6]<kolbtab[6]) colbtab[6]++;
		asm { 	mov dx,03c8h
			mov al,7
			out dx,al
			inc dx
			mov al,colrtab[7]
			out dx,al
			mov al,colgtab[7]
			out dx,al
			mov al,colbtab[7]
			out dx,al }
		if (colrtab[7]<kolrtab[7]) colrtab[7]++;
		if (colgtab[7]<kolgtab[7]) colgtab[7]++;
		if (colbtab[7]<kolbtab[7]) colbtab[7]++;
		asm { 	mov dx,03c8h
			mov al,56
			out dx,al
			inc dx
			mov al,colrtab[8]
			out dx,al
			mov al,colgtab[8]
			out dx,al
			mov al,colbtab[8]
			out dx,al }
		if (colrtab[8]<kolrtab[8]) colrtab[8]++;
		if (colgtab[8]<kolgtab[8]) colgtab[8]++;
		if (colbtab[8]<kolbtab[8]) colbtab[8]++;
		asm { 	mov dx,03c8h
			mov al,57
			out dx,al
			inc dx
			mov al,colrtab[9]
			out dx,al
			mov al,colgtab[9]
			out dx,al
			mov al,colbtab[9]
			out dx,al }
		if (colrtab[9]<kolrtab[9]) colrtab[9]++;
		if (colgtab[9]<kolgtab[9]) colgtab[9]++;
		if (colbtab[9]<kolbtab[9]) colbtab[9]++;
		asm { 	mov dx,03c8h
			mov al,58
			out dx,al
			inc dx
			mov al,colrtab[10]
			out dx,al
			mov al,colgtab[10]
			out dx,al
			mov al,colbtab[10]
			out dx,al }
		if (colrtab[10]<kolrtab[10]) colrtab[10]++;
		if (colgtab[10]<kolgtab[10]) colgtab[10]++;
		if (colbtab[10]<kolbtab[10]) colbtab[10]++;
		asm { 	mov dx,03c8h
			mov al,59
			out dx,al
			inc dx
			mov al,colrtab[11]
			out dx,al
			mov al,colgtab[11]
			out dx,al
			mov al,colbtab[11]
			out dx,al }
		if (colrtab[11]<kolrtab[11]) colrtab[11]++;
		if (colgtab[11]<kolgtab[11]) colgtab[11]++;
		if (colbtab[11]<kolbtab[11]) colbtab[11]++;
		asm { 	mov dx,03c8h
			mov al,60
			out dx,al
			inc dx
			mov al,colrtab[12]
			out dx,al
			mov al,colgtab[12]
			out dx,al
			mov al,colbtab[12]
			out dx,al }
		if (colrtab[12]<kolrtab[12]) colrtab[12]++;
		if (colgtab[12]<kolgtab[12]) colgtab[12]++;
		if (colbtab[12]<kolbtab[12]) colbtab[12]++;
		asm { 	mov dx,03c8h
			mov al,61
			out dx,al
			inc dx
			mov al,colrtab[13]
			out dx,al
			mov al,colgtab[13]
			out dx,al
			mov al,colbtab[13]
			out dx,al }
		if (colrtab[13]<kolrtab[13]) colrtab[13]++;
		if (colgtab[13]<kolgtab[13]) colgtab[13]++;
		if (colbtab[13]<kolbtab[13]) colbtab[13]++;
		asm { 	mov dx,03c8h
			mov al,62
			out dx,al
			inc dx
			mov al,colrtab[14]
			out dx,al
			mov al,colgtab[14]
			out dx,al
			mov al,colbtab[14]
			out dx,al }
		if (colrtab[14]<kolrtab[14]) colrtab[14]++;
		if (colgtab[14]<kolgtab[14]) colgtab[14]++;
		if (colbtab[14]<kolbtab[14]) colbtab[14]++;
		asm { 	mov dx,03c8h
			mov al,63
			out dx,al
			inc dx
			mov al,colrtab[15]
			out dx,al
			mov al,colgtab[15]
			out dx,al
			mov al,colbtab[15]
			out dx,al }
		if (colrtab[15]<kolrtab[15]) colrtab[15]++;
		if (colgtab[15]<kolgtab[15]) colgtab[15]++;
		if (colbtab[15]<kolbtab[15]) colbtab[15]++;
	}
}
void initcolors(void) {
	 colrtab[1]=12;
	 colgtab[1]=12;
	 colbtab[1]=12;
	 colrtab[2]=24;
	 colgtab[2]=24;
	 colbtab[2]=24;
	 colrtab[3]=36;
	 colgtab[3]=36;
	 colbtab[3]=36;
	 colrtab[4]=30;
	 colgtab[4]=0;
	 colbtab[4]=30;
	 colrtab[5]=60;
	 colgtab[5]=0;
	 colbtab[5]=60;
	 colrtab[6]=0;
	 colgtab[6]=30;
	 colbtab[6]=30;
	 colrtab[7]=0;
	 colgtab[7]=60;
	 colbtab[7]=60;
	 colrtab[8]=0;
	 colgtab[8]=0;
	 colbtab[8]=30;
	 colrtab[9]=0;
	 colgtab[9]=0;
	 colbtab[9]=60;
	 colrtab[10]=0;
	 colgtab[10]=30;
	 colbtab[10]=0;
	 colrtab[11]=0;
	 colgtab[11]=60;
	 colbtab[11]=0;
	 colrtab[12]=30;
	 colgtab[12]=0;
	 colbtab[12]=0;
	 colrtab[13]=60;
	 colgtab[13]=0;
	 colbtab[13]=0;
	 colrtab[14]=58;
	 colgtab[14]=58;
	 colbtab[14]=0;
	 colrtab[15]=60;
	 colgtab[15]=60;
	 colbtab[15]=60;
}

void gammacorrect() {
	int i,n;
	unsigned char r;
	unsigned char g;
	unsigned char b;
	syncdisplay();
	if (gcorrect>=3) { gcorrect=0; initcolor(); } else {
	gcorrect++;
	for (i=0; i<256; i++) {
		asm {	mov dx,0x03c7
			mov ax,i
			out dx,al
			mov dx,0x03c9
			in al,dx
			mov r,al
			in al,dx
			mov g,al
			in al,dx
			mov b,al }
			if(r<64) r++;
			if(g<64) g++;
			if(b<64) b++;
		 asm { 	mov dx,0x03c8
			mov ax,i
			out dx,al
			mov dx,0x03c9
			mov al,r
			out dx,al
			mov al,g
			out dx,al
			mov al,b
			out dx,al } } } }


void initcolor(void) {
	syncdisplay();
	setrgb(0,0,0,0);	// color 0 black
	setrgb(1,12,12,12);     // color 1 black+
	setrgb(2,24,24,24);     // color 2 black++
	setrgb(3,36,36,36);     // color 3 black+++
	setrgb(4,30,0,30);
	setrgb(5,60,0,60);
	setrgb(20,0,30,30);
	setrgb(7,0,60,60);
	setrgb(56,0,0,30);	// color 8 blue
	setrgb(57,0,0,60);      // color 9
	setrgb(58,0,30,0);
	setrgb(59,0,60,0);
	setrgb(60,30,0,0);	// color 12 red
	setrgb(61,60,0,0);	// color 13
	setrgb(62,58,58,0);	// color 14 yellow
	setrgb(63,60,60,60);    // color 15 white
}

void setrgb(int i, unsigned char r, unsigned char g, unsigned char b) {
asm { 	mov dx,0x03c8
	mov ax,i
	out dx,al
	mov dx,0x03c9
	mov al,r
	out dx,al
	mov al,g
	out dx,al
	mov al,b
	out dx,al } }

void syncdisplay() {
    asm mov dx,0x03DA
l1: asm {
	in al,dx
	and al,8
	jnz l1 }
l2: asm {
	in al,dx
	and al,8
	jz l2 } }

void resetcolors(void) {       int n;
	for (n=0; n<15; n++) {
	colrtab[n]=0;
	colgtab[n]=0;
	colbtab[n]=0;
} }


void initglass() {
	int n;
	for (n=0; n<sizeof(glass); n++) glass[n]=0;
	for (n=0; n<416;) {
		glass[n]=1;
		n+=15;
		glass[n]=1;
		n++;
	}
	for (n=400; n<416; n++) glass[n]=1;
}

void fillglass(int diff) {
	int n;
	int diff1;

	initglass();
	if(diff<=1) return;
	diff1 = 399-(diff*16*3);
	for (n=399; n>diff1; n--)
		if ((rand()*diff)<=10)
			glass[n]=(2+random(14))&0x0E;
	for (n=0; n<416;) {
		glass[n]=1;
		n+=15;
		glass[n]=1;
		n++;
	}
	for (n=400; n<416; n++) glass[n]=1;
}

void mainmenu() {
	int active;
	int i,x,y,l,c;
	unsigned char gc,gt,old_g_count;
	unsigned char old_g_minutes,old_g_hours;
	unsigned char old_p_minutes,old_p_hours;
	int activex[12]={ 130,130,130,130,130,130,130,130,130,130, 170,364};
	int activey[12]={  99,113,127,141,155,169,183,197,211,225, 251,251};
	int activel[12]={ 184,184,184,184,184,184,184,184,184,184, 100,100};
	char *cpumsg[]={ "Unknoun","8086","80286","80386","80486","PENTIUM","PPro/II","P-III" };

redraw: lopez=0; // no redraw
	gc=g_count;
	gt=0;
	old_g_minutes=g_minutes; old_g_hours=g_hours;
	old_p_minutes=p_minutes; old_p_hours=p_hours;
	setactivepage(1);
	screen=0xA960;
	clearscreen();
	drawstars();
	plotglass();
	box(120,40,520,280,2); box(126,46,513,270,1);
	colour(3); linex(120,40,520,40); linex(120,40,120,280);
	colour(1); linex(120,280,520,280); linex(520,41,520,280);
	colour(3); linex(126,270,513,270); linex(513,46,513,270);
	setcolour(3);  print(211,51,"STAR TETRIS II  GAME MENU");
	setcolour(15); print(210,50,"STAR TETRIS II  GAME MENU");
	linex(127,62,512,62); colour(2); linex(320,68,320,246);

	setcolour(3);  print(151,77,"InGame Variables:");
	setcolour(15); print(150,76,"InGame Variables:");
	setcolour(3);  print(345,77,"System Information:");
	setcolour(15); print(344,76,"System Information:");
	putchoise();

// InGame Variables:
	setcolour(2); print(141,101,"Mouse"); setcolour(3); print(140,100,"Mouse");
	setcolour(2); print(141,115,"Music"); setcolour(3); print(140,114,"Music");
	setcolour(2); print(141,129,"GameMode"); setcolour(3); print(140,128,"GameMode");
	setcolour(2); print(141,143,"StarGrid");  setcolour(3); print(140,142,"StarGrid");
	setcolour(2); print(141,157,"FrameSync"); setcolour(3); print(140,156,"FrameSync");
	setcolour(2); print(141,171,"Background"); setcolour(3); print(140,170,"Background");
	setcolour(2); print(141,185,"GammaCorrect."); setcolour(3); print(140,184,"GammaCorrect.");
	setcolour(2); print(141,199,"MusicVolume"); setcolour(3); print(140,198,"MusicVolume");
	setcolour(2); print(141,213,"SpaceRadar"); setcolour(3); print(140,212,"SpaceRadar");
	setcolour(2); print(141,227,"ShowNextFigure"); setcolour(3); print(140,226,"ShowNextFigure");

	if (mouseon==0) { setcolour(2); print(281,101,"on"); setcolour(3); print(280,100,"on"); }
	else { setcolour(2); print(281,101,"off"); setcolour(3); print(280,100,"off"); }
	if (musicon==0) { setcolour(2); print(281,115,"on"); setcolour(3); print(280,114,"on"); }
	else { setcolour(2); print(281,115,"off"); setcolour(3); print(280,114,"off"); }
	if (gamemode==0) { setcolour(2); print(281,129,"hard"); setcolour(3); print(280,128,"hard"); }
	else { setcolour(2); print(281,129,"easy"); setcolour(3); print(280,128,"easy"); }
	if (net==0) { setcolour(2); print(281,143,"on"); setcolour(3); print(280,142,"on"); }
	else { setcolour(2); print(281,143,"off"); setcolour(3); print(280,142,"off"); }
	if (framesync==0) { setcolour(2); print(281,157,"on"); setcolour(3); print(280,156,"on"); }
	else { setcolour(2); print(281,157,"off"); setcolour(3); print(280,156,"off"); }
	if (background==0) { setcolour(2); print(281,171,"on"); setcolour(3); print(280,170,"on"); }
	else { setcolour(2); print(281,171,"off"); setcolour(3); print(280,170,"off"); }
	setcolour(2); print(281,185,"%d",gcorrect); setcolour(3); print(280,184,"%d",gcorrect);
	setcolour(2); print(281,199,"%d",sbvolume); setcolour(3); print(280,198,"%d",sbvolume);
	if (radaron==0) { setcolour(2); print(281,213,"on"); setcolour(3); print(280,212,"on"); }
	else { setcolour(2); print(281,213,"off"); setcolour(3); print(280,212,"off"); }
	if (shownext==0) { setcolour(2); print(281,227,"on"); setcolour(3); print(280,226,"on"); }
	else { setcolour(2); print(281,227,"off"); setcolour(3); print(280,226,"off"); }


//System Information:
	setcolour(2); print(337,101,"CPU Type:"); setcolour(3); print(336,100,"CPU Type:");
	setcolour(2); print(337,115,"DOS Version:"); setcolour(3); print(336,114,"DOS Version:");
	setcolour(2); print(337,129,"Running under:"); setcolour(3); print(336,128,"Running under:");
	setcolour(2); print(337,151,"Difficulty:"); setcolour(3); print(336,150,"Difficulty:");
	setcolour(2); print(337,165,"InGame Time:"); setcolour(3); print(336,164,"InGame Time:");
	setcolour(2); print(337,179,"InPlay Time:"); setcolour(3); print(336,178,"InPlay Time:");

	setcolour(2); print(451,101,cpumsg[cpu_type]); setcolour(3); print(450,100,cpumsg[cpu_type]);
	setcolour(2); print(451,115,"%c.%c%c",dos_bl,dos_ah,dos_al); setcolour(3); print(450,114,"%c.%c%c",dos_bl,dos_ah,dos_al);
	if (run_al==0) { setcolour(2); print(455,129,"BIOS"); setcolour(3); print(454,128,"BIOS"); }
	if (run_al==1) { setcolour(2); print(455,129,"XMS" ); setcolour(10); print(454,128,"XMS"); }
	if (run_al==2) { setcolour(2); print(455,129,"VCPI"); setcolour(12); print(454,128,"VCPI"); }
	if (run_al==3) { setcolour(2); print(455,129,"DPMI"); setcolour(12); print(454,128,"DPMI"); }
	setcolour(2); print(451,151,"%d",difficulty); setcolour(3); print(450,150,"%d",difficulty);
	setcolour(2); print(451,165,"%02d %02d",g_hours,g_minutes); setcolour(3); print(450,164,"%02d %02d",g_hours,g_minutes);
	setcolour(2); print(451,179,"%02d %02d",p_hours,p_minutes); setcolour(3); print(450,178,"%02d %02d",p_hours,p_minutes);


	screen=0xA000;
	setactivepage(0);
	syncdisplay();
	copyscreen();
	key=0;
	xmouse=0;
	ymouse=0;
	active=0;
	x=activex[active]; y=activey[active]; l=activel[active]; negfelt(x,y,l);
	gc=g_count;
	old_g_count=g_count;
	gt=1;
	old_g_minutes=g_minutes; old_g_hours=g_hours;
	old_p_minutes=p_minutes; old_p_hours=p_hours;

	do {
	if (g_minutes!=old_g_minutes) { old_g_minutes=g_minutes;
					syncdisplay(); box(474,164,492,174,1);
					setcolor(2); print(475,165,"%02d",g_minutes);
					setcolor(3); print(474,164,"%02d",g_minutes); }
	if (g_hours!=old_g_hours) { old_g_hours=g_hours;
					syncdisplay(); box(450,164,467,174,1);
					setcolor(2); print(451,165,"%02d",g_hours);
					setcolor(3); print(450,164,"%02d",g_hours); }
	if (p_minutes!=old_p_minutes) { old_p_minutes=p_minutes;
					syncdisplay(); box(474,178,492,188,1);
					setcolor(2); print(475,179,"%02d",p_minutes);
					setcolor(3); print(474,178,"%02d",p_minutes); }
	if (p_hours!=old_p_hours) { old_p_hours=p_hours;
					syncdisplay(); box(450,178,467,188,1);
					setcolor(2); print(451,179,"%02d",p_hours);
					setcolor(3); print(450,178,"%02d",p_hours); }
	if (g_count!=old_g_count) { gc=gc+(g_count-old_g_count); old_g_count=g_count; }
	if (gc>18 && gt==0) { box(466,164,472,172,1); box(466,178,472,186,1);gc=0; gt=1; }
	if (gc>18 && gt==1) { gc=0; gt=0; setcolor(2); print(467,165,":"); setcolor(3); print(466,164,":");
				setcolor(2); print(467,179,":"); setcolor(3); print(466,178,":"); }

	if (nokey!=0) { nokey--; syncdisplay(); } else {
	if (key==80 && active<11) {
		x=activex[active]; y=activey[active]; l=activel[active]; negfelt(x,y,l);
		nokey=5; active++; putchoise();
		x=activex[active]; y=activey[active]; l=activel[active]; negfelt(x,y,l); }
	if (key==72 && active>0) {
		x=activex[active]; y=activey[active]; l=activel[active]; negfelt(x,y,l);
		nokey=5; active--; putchoise();
		x=activex[active]; y=activey[active]; l=activel[active]; negfelt(x,y,l); }

	if (key==77) changeset(active);
	if (key==75) changeset(active);
	if (key==0x1C) changeset(active);
	if (lopez!=0) goto redraw;
	} } while (key!=1 && key!=0x58);

	if (mouseis==0) {
	  asm { mov ax,0x0B
		int 0x33 } }
	setactivepage(1);
	screen=0xA960;
	delay(100);
	nokey=0;
	key=0;
}

void changeset(int action) {
	int k;
	k=key;
	switch(action) {

	case 0:         setcolour(15); putmouse(); screen=0xA000; setactivepage(0);
			box(280,100,308,109,6);
			if (mouseon==0) { setcolour(2); print(281,101,"on"); setcolour(3); print(280,100,"on"); }
			else { setcolour(2); print(281,101,"off"); setcolour(3); print(280,100,"off"); }
			break;
	case 1:		setcolour(15); putmusic(); screen=0xA000; setactivepage(0);
			box(280,114,308,123,6);
			if (musicon==0) { setcolour(2); print(281,115,"on"); setcolour(3); print(280,114,"on"); }
			else { setcolour(2); print(281,115,"off"); setcolour(3); print(280,114,"off"); }
			box(280,198,312,207,1);
			setcolour(2); print(281,199,"%d",sbvolume); setcolour(3); print(280,198,"%d",sbvolume);
			break;
	case 2:		setcolour(15); putmode(); screen=0xA000; setactivepage(0);
			box(280,128,312,137,6);
			if (gamemode==0) { setcolour(2); print(281,129,"hard"); setcolour(3); print(280,128,"hard"); }
			else { setcolour(2); print(281,129,"easy"); setcolour(3); print(280,128,"easy"); }
			break;
	case 3:		net=net^1;
			box(280,142,312,151,6);
			if (net==0) { setcolour(2); print(281,143,"on"); setcolour(3); print(280,142,"on"); }
			else { setcolour(2); print(281,143,"off"); setcolour(3); print(280,142,"off"); }
			break;
	case 4:		framesync=framesync^1;
			box(280,156,312,165,6);
			if (framesync==0) { setcolour(2); print(281,157,"on"); setcolour(3); print(280,156,"on"); }
			else { setcolour(2); print(281,157,"off"); setcolour(3); print(280,156,"off"); }
			break;
	case 5:		setbackground();
			box(280,170,312,179,6);
			if (background==0) { setcolour(2); print(281,171,"on"); setcolour(3); print(280,170,"on"); }
			else { setcolour(2); print(281,171,"off"); setcolour(3); print(280,170,"off"); }
			break;
	case 6:		gammacorrect();
			box(280,184,312,193,6);
			setcolour(2); print(281,185,"%d",gcorrect); setcolour(3); print(280,184,"%d",gcorrect);
			break;

	case 7:         if (k==0x1C) { sbvolume=oldsbvolume; setvolume(); }  else
			if (k==75 && sbvolume>0) { sbvolume--; setvolume(); maxvolume=sbvolume; } else
			if (k==77 && sbvolume<15) { sbvolume++; setvolume(); maxvolume=sbvolume; }
			box(280,198,312,207,6);
			setcolour(2); print(281,199,"%d",sbvolume); setcolour(3); print(280,198,"%d",sbvolume);
			break;
	case 8:		setradar();
			screen=0xA000; setactivepage(0);
			box(280,212,312,221,6);
			if (radaron==0) { setcolour(2); print(281,213,"on"); setcolour(3); print(280,212,"on"); }
			else { setcolour(2); print(281,213,"off"); setcolour(3); print(280,212,"off"); }
			break;
	case 9:		shownext=shownext^1;
			box(280,226,312,235,6);
			if (shownext==0) { setcolour(2); print(281,227,"on"); setcolour(3); print(280,226,"on"); }
			else { setcolour(2); print(281,227,"off"); setcolour(3); print(280,226,"off"); }
			break;

	case 10:	if (k==0x1C) { savegame(); lopez=1; break; } else { lopez=0; break; }
	case 11:	if (k==0x1C) { loadgame(); lopez=1; break; } else { lopez=0; break; }
	}
	do delay(5); while (key==k);
}

void putchoise() {
	setcolour(3); print(184,253,"Save Game"); setcolour(14); print(183,252,"Save Game");
	setcolour(3); print(381,253,"Load Game"); setcolour(14); print(380,252,"Load Game");
}

void putexit() {
	setcolour(3); print(301,265,"Exit"); setcolour(14); print(300,264,"Exit");
}



void negfelt(int x1, int y1, int len) {
	int x,y,i,c;
	syncdisplay();
	for (y=0; y<10; y++) {
	for (x=0; x<len; x++) {
		asm mov si,x1
		asm add si,x
		asm mov di,y1
		asm add di,y
		plop();
		asm mov i,ax
		if (i==1) c=6; else c=i;
		if (i==6) c=1;
		asm mov ax,x
		asm add ax,x1
		asm mov bx,y
		asm add bx,y1
		asm mov cx,c
		plot(); } }
}

void stopit(void) {
	key=0;
	delay(30);
	do syncdisplay(); while (key==0);
}

void makefilename(int f) {
	int n;
	char c;
	for (n=0; n<14; n++) filename[n]=savedfile[n];
	c=f+0x0030;
	filename[7]=c;
}

int entergamename(int active) {
	int n,x,y,k;
	char sk;
	char *name="                    ";
	x=274;
	y=80+active*16;
	box(x,y,x+130,y+10,1);
	for (n=0; n<16; n++) name[n]=32;
	for (n=0; n<16; n++) {
l0:
		key=0;
		do {
			setcolor(3); outtextxy(x+1,y+1,"_");
			setcolor(15); outtextxy(x,y,"_");
			syncdisplay();
			delay(5);
			syncdisplay();
			box(x,y,x+10,y+10,1);
		} while(key==0);
		sk=key;
		k=keydecode(sk);
		if (sk==1) goto l1;
		if (sk==0x1C) goto l2;
		if (k==12) if (n>0) { n--; name[n]=32; x-=8; }
		if (k<32) goto l0;
		setcolor(3); print(x+1,y+1,"%c",k);
		setcolor(15); print(x,y,"%c",k);
		name[n]=k;
		x+=8;
	}
l2:	for (n=0; n<16; n++) gamename[n]=name[n];
	return(0);
l1:	return(1);
}

int load_desk() {
	int n,i,active,handle, x,y,l;
	char *name="                    ";
	int slot[11]={0,0,0,0,0,0,0,0,0,0,0};
	int activex[11]={ 216,216,216,216,216,216,216,216,216,216, 290 };
	int activey[11]={  79, 95,111,127,143,159,175,191,207,223, 263 };
	int activel[11]={ 204,204,204,204,204,204,204,204,204,204,  50 };
	setactivepage(1);
	screen=0xA960;
	box(190,20,450,300,2); box(194,30,446,290,1);
	colour(3); linex(190,20,450,20); linex(190,20,190,300);
	colour(1); linex(190,300,450,300); linex(450,21,450,300);
	colour(3); linex(194,290,446,290); linex(446,30,446,290);
	setcolour(3); print(261,35,"LOAD GAME MENU");
	setcolour(15); print(260,34,"LOAD GAME MENU"); linex(195,48,445,48);
	putexit();
	_fmode = O_BINARY;
	for (n=0; n<10; n++) {
		setcolour(3);  print(231,81+n*16,"%d.",n+1);
		setcolour(15); print(230,80+n*16,"%d.",n+1); }
	for (n=0; n<10; n++) {
		makefilename(n);
		if ((handle=open(filename,O_RDWR)) !=-1) {
			read(handle,savebuf,2022); close(handle);
			for(i=0; i<16; i++) name[i]=savebuf[32+i];
			name[16]=0; name[17]=0;
			slot[n]=1;
			setcolour(3);  print(275,81+n*16,name);
			setcolour(15); print(274,80+n*16,name); }
		else {	slot[n]=0;
			setcolour(2); print(301,81+n*16,"EMPTY SLOT");
			setcolour(3); print(300,80+n*16,"EMPTY SLOT"); } }
	screen=0xA000;
	setactivepage(0);
	syncdisplay();
	copyscreen();
	key	=0;
	xmouse	=0;
	ymouse	=0;
	active	=0;
	x=activex[active]; y=activey[active]; l=activel[active]; negfelt(x,y,l);
	do {
	if (nokey!=0) { nokey--; syncdisplay(); } else {
	if (key==80 && active<10) {
		x=activex[active]; y=activey[active]; l=activel[active];
		negfelt(x,y,l); nokey=5; active++; putexit();
		x=activex[active]; y=activey[active]; l=activel[active]; negfelt(x,y,l); }
	if (key==72 && active>0) {
		x=activex[active]; y=activey[active]; l=activel[active];
		negfelt(x,y,l); nokey=5; active--; putexit();
		x=activex[active]; y=activey[active]; l=activel[active]; negfelt(x,y,l); }
	if (key==0x1C) goto l1;
	} } while (key!=1 && key!=0x58);
l1:     if (key==1) active=10;
	if (mouseis==0) {
	  asm { mov ax,0x0B
		int 0x33 } }
	if (slot[active]==0) active=10;
	return(active);
}


int save_desk() {
	int n,i,active,handle, x,y,l;
	char *name="                    ";
	int slot[11]={0,0,0,0,0,0,0,0,0,0,0};
	int activex[11]={ 216,216,216,216,216,216,216,216,216,216, 290 };
	int activey[11]={  79, 95,111,127,143,159,175,191,207,223, 263 };
	int activel[11]={ 204,204,204,204,204,204,204,204,204,204,  50 };
	setactivepage(1);
	screen=0xA960;
	box(190,20,450,300,2); box(194,30,446,290,1);
	colour(3); linex(190,20,450,20); linex(190,20,190,300);
	colour(1); linex(190,300,450,300); linex(450,21,450,300);
	colour(3); linex(194,290,446,290); linex(446,30,446,290);
	setcolour(3);  print(261,35,"SAVE GAME MENU");
	setcolour(15); print(260,34,"SAVE GAME MENU"); linex(195,48,445,48);
	putexit();
	_fmode = O_BINARY;
	for (n=0; n<10; n++) {
		setcolour(3);  print(231,81+n*16,"%d.",n+1);
		setcolour(15); print(230,80+n*16,"%d.",n+1); }
l0:	for (n=0; n<10; n++) {
		makefilename(n);
		if ((handle=open(filename,O_RDWR)) !=-1) {
			read(handle,savebuf,2022); close(handle);
			for(i=0; i<16; i++) name[i]=savebuf[32+i];
			name[16]=0; name[17]=0;
			slot[n]=1;
			setcolour(3);  print(275,81+n*16,name);
			setcolour(15); print(274,80+n*16,name); }
		else {	slot[n]=0;
			setcolour(2); print(301,81+n*16,"EMPTY SLOT");
			setcolour(3); print(300,80+n*16,"EMPTY SLOT"); } }
	screen=0xA000;
	setactivepage(0);
	syncdisplay();
	copyscreen();
	key=0;
	xmouse=0;
	ymouse=0;
	active=0;
	x=activex[active]; y=activey[active]; l=activel[active]; negfelt(x,y,l);
	do {
	if (nokey!=0) { nokey--; syncdisplay(); } else {
	if (key==80 && active<10) {
		x=activex[active]; y=activey[active]; l=activel[active];
		negfelt(x,y,l); nokey=5; active++; putexit();
		x=activex[active]; y=activey[active]; l=activel[active]; negfelt(x,y,l); }
	if (key==72 && active>0) {
		x=activex[active]; y=activey[active]; l=activel[active];
		negfelt(x,y,l); nokey=5; active--; putexit();
		x=activex[active]; y=activey[active]; l=activel[active]; negfelt(x,y,l); }
	if (key==0x1C) goto l1;
	} } while (key!=1 && key!=0x58);
	if (key==1) active=10;
	goto l2;
l1:	x=activex[active]; y=activey[active]; l=activel[active]; negfelt(x,y,l);
	if (active==10) goto l2;
	n=entergamename(active);
	if (n!=0) goto l0;
l2:     if (mouseis==0) {
	   asm { mov ax,0x0B
		int 0x33 } }
	return(active);
}




int savegame() {
	int n,ptr,handle;
	char *msg1="STAR TETRIS II";
	char *msg2="Version: #";
	sfig_count=1;			// disable sfig
	n=save_desk();
	if (n==10) goto l1;
	makefilename(n);
	ptr=0;
	for (n=0; n<2048; n++) savebuf[n]=0;
	for (n=0; n<14; n++) { savebuf[ptr]=msg1[n]; ptr++; }
	savebuf[ptr]=13; ptr++; savebuf[ptr]=10; ptr++;
	for (n=0; n<10; n++) { savebuf[ptr]=msg2[n]; ptr++; }
	for (n=0; n<4; n++) { savebuf[ptr]=version[n]; ptr++; }
	savebuf[ptr]=13; ptr++; savebuf[ptr]=10; ptr++;
	for (n=0; n<16; n++) { savebuf[ptr]=gamename[n]; ptr++; }
	ptr+=0x10;
	for (n=0; n<512; n++) { savebuf[ptr]=glass[n]; ptr++; }
	for (n=0; n<25; n++) { savebuf[ptr]=figt[n]; ptr++; }
	for (n=0; n<25; n++) { savebuf[ptr]=scanl[n]; ptr++; }
	for (n=0; n<25; n++) { savebuf[ptr]=figtab[n]; ptr++; }

	ptr+=14; // save configuration
	savebuf[ptr+0]=mouseon;
	savebuf[ptr+2]=musicon;
	savebuf[ptr+4]=gamemode;
	savebuf[ptr+6]=net;
	savebuf[ptr+8]=framesync;
	savebuf[ptr+10]=background;
	savebuf[ptr+12]=gcorrect;
	savebuf[ptr+14]=sbvolume;
	savebuf[ptr+16]=radaron;
	savebuf[ptr+17]=shownext;

	ptr+=18; // save game variable
	savebuf[ptr+0]= scany;
	savebuf[ptr+2]= fmov;
	savebuf[ptr+4]= frot;
	savebuf[ptr+8]= fdrop;
	savebuf[ptr+10]= mdrop;
	savebuf[ptr+12]= afig;
	savebuf[ptr+14]= acol;
	savebuf[ptr+16]= xfig;
	savebuf[ptr+18]= yfig;
	savebuf[ptr+20]= sfig;
	savebuf[ptr+22]= lfig;
	savebuf[ptr+24]= newfig;
	savebuf[ptr+26]= figsize;
	savebuf[ptr+28]= afignext;
	savebuf[ptr+29]= acolnext;

	ptr+=30; n=ptr; // save game status
	asm push bx
	asm mov bx,n
	asm mov al,byte ptr score[0];
	asm mov byte ptr savebuf[bx+0],al;
	asm mov al,byte ptr score[1];
	asm mov byte ptr savebuf[bx+1],al;
	asm mov al,byte ptr score[2];
	asm mov byte ptr savebuf[bx+2],al;
	asm mov al,byte ptr score[3];
	asm mov byte ptr savebuf[bx+3],al;	//savebuf[ptr+0]= score;
	asm pop bx
	savebuf[ptr+4]= level;
	savebuf[ptr+6]= difficulty;
	savebuf[ptr+8]= scorex;
	savebuf[ptr+10]= slines;
	savebuf[ptr+12]= tlines;
	savebuf[ptr+14]= p_count;
	savebuf[ptr+15]= p_seconds;
	savebuf[ptr+16]= p_minutes;
	savebuf[ptr+17]= p_hours;

	ptr+=20;
	savebuf[ptr+0]= speed;
	savebuf[ptr+2]= tempc;
	savebuf[ptr+4]= tempd;
	savebuf[ptr+6]= tempn;
	savebuf[ptr+8]= gameend;
	savebuf[ptr+10]= maxstars;
	savebuf[ptr+12]= cursor;
	savebuf[ptr+14]= curpas;

	ptr+=20;
	for(n=0; n<80; n++){ savebuf[ptr]=scsbuf[n]; ptr++; }

	_fmode = O_BINARY;
	if ( (handle=open(filename,O_RDWR))==-1 ) {
	if ( (handle=creat(filename, S_IREAD|S_IWRITE))==-1) save_error(); }
	if ( write(handle,savebuf,2022)==-1 ) save_error();
	if ( close(handle)==-1 ) save_error();
l1:     key=0;
	setactivepage(1);
	screen=0xA960;
	sfig_count=0;			// enable sfig
	return(0);
}

int loadgame() {
	int n,ptr,handle;
	char *msg1="STAR TETRIS II";
	char *msg2="Version: #";
	sfig_count=1;
	n=load_desk();
	if (n==10) { n=1; goto l1; }
	makefilename(n);
	_fmode = O_BINARY;
	for (n=0; n<2048; n++) savebuf[n]=0;
	if ( (handle=open(filename,O_RDWR | O_BINARY))==-1 ) load_error();
	if ( read(handle,savebuf,2022)==-1 ) load_error();
	close(handle);
	ptr=0;
	for (n=0; n<14; n++) { if(savebuf[ptr]!=msg1[n]) load_error2(); else ptr++; }
	ptr+=2;
	for (n=0; n<10; n++) { if(savebuf[ptr]!=msg2[n]) load_error2(); else ptr++; }
	for (n=0; n<4; n++) { if(savebuf[ptr]!=version[n]) load_error3(); else ptr++; }
	ptr+=2;	ptr+=0x20;
	for (n=0; n<512; n++) { glass[n]=savebuf[ptr]; ptr++; }
	for (n=0; n<25; n++) { figt[n]=savebuf[ptr]; ptr++; }
	for (n=0; n<25; n++) { scanl[n]=savebuf[ptr]; ptr++; }
	for (n=0; n<25; n++) { figtab[n]=savebuf[ptr]; ptr++; }

	ptr+=14; // restore configuration
	mouseon	=savebuf[ptr+0];
	musicon	=savebuf[ptr+2];
	gamemode=savebuf[ptr+4];
	net	=savebuf[ptr+6];
	framesync=savebuf[ptr+8];
	background=savebuf[ptr+10];
	gcorrect=savebuf[ptr+12];
	sbvolume=savebuf[ptr+14];
	radaron	=savebuf[ptr+16];
	shownext=savebuf[ptr+17];

	ptr+=18; // restore game configuration
	scany =savebuf[ptr+0];
	fmov =savebuf[ptr+2];
	frot =savebuf[ptr+4];
	fdrop =savebuf[ptr+8];
	mdrop =savebuf[ptr+10];
	afig =savebuf[ptr+12];
	acol =savebuf[ptr+14];
	xfig =savebuf[ptr+16];
	yfig =savebuf[ptr+18];
	sfig =savebuf[ptr+20];
	lfig =savebuf[ptr+22];
	newfig=savebuf[ptr+24];
	figsize=savebuf[ptr+26];
	afignext=savebuf[ptr+28];
	acolnext=savebuf[ptr+29];

	ptr+=30; n=ptr; // restore game status
	asm push bx
	asm mov bx,n
	asm mov al,byte ptr savebuf[bx+0]
	asm mov byte ptr score[0],al
	asm mov al,byte ptr savebuf[bx+1]
	asm mov byte ptr score[1],al
	asm mov al,byte ptr savebuf[bx+2]
	asm mov byte ptr score[2],al
	asm mov al,byte ptr savebuf[bx+3]	//savebuf[ptr+0]= score;
	asm mov byte ptr score[3],al
	asm pop bx
	level =savebuf[ptr+4];
	difficulty =savebuf[ptr+6];
	scorex =savebuf[ptr+8];
	slines =savebuf[ptr+10];
	tlines =savebuf[ptr+12];
	p_count=savebuf[ptr+14];
	p_seconds=savebuf[ptr+15];
	p_minutes=savebuf[ptr+16];
	p_hours=savebuf[ptr+17];

	ptr+=20;
	speed =savebuf[ptr+0];
	tempc =savebuf[ptr+2];
	tempd =savebuf[ptr+4];
	asm mov ax,tempd;
	asm movsx ax,al;
	asm mov tempd,ax;
	tempn =savebuf[ptr+6];
	gameend =savebuf[ptr+8];
	maxstars =savebuf[ptr+10];

	ptr+=20;
	load_update();
	n=0;
l1:     key=0;
	setactivepage(1);
	screen=0xA960;
	sfig_count=0;
	return(n);
}


int loadgamerightaway(char *argv) {
	int n,ptr,handle;
	char game;
	char *msg1="STAR TETRIS II";
	char *msg2="Version: #";
	sfig_count=1;
	game=argv[6];
	asm mov al,game
	asm sub al,0x30
	asm mov ah,0x00
	asm mov n,ax
	if (n<0) n=10;
	if (n>9) n=10;
	if (n==10) { n=1; goto l1; }
	makefilename(n);

	for (n=0; n<2048; n++) savebuf[n]=0;
	if ( (handle=open(filename,O_RDWR | O_BINARY))==-1 ) load_error();
	if ( read(handle,savebuf,2022)==-1 ) load_error();
	close(handle);
	ptr=0;
	for (n=0; n<14; n++) { if(savebuf[ptr]!=msg1[n]) load_error2(); else ptr++; }
	ptr+=2;
	for (n=0; n<10; n++) { if(savebuf[ptr]!=msg2[n]) load_error2(); else ptr++; }
	for (n=0; n<4; n++) { if(savebuf[ptr]!=version[n]) load_error3(); else ptr++; }
	ptr+=2;	ptr+=0x20;
	for (n=0; n<512; n++) { glass[n]=savebuf[ptr]; ptr++; }
	for (n=0; n<25; n++) { figt[n]=savebuf[ptr]; ptr++; }
	for (n=0; n<25; n++) { scanl[n]=savebuf[ptr]; ptr++; }
	for (n=0; n<25; n++) { figtab[n]=savebuf[ptr]; ptr++; }

	ptr+=14; // restore configuration
	mouseon	=savebuf[ptr+0];
	musicon	=savebuf[ptr+2];
	gamemode=savebuf[ptr+4];
	net	=savebuf[ptr+6];
	framesync=savebuf[ptr+8];
	background=savebuf[ptr+10];
	gcorrect=savebuf[ptr+12];
	sbvolume=savebuf[ptr+14];
	radaron	=savebuf[ptr+16];
	shownext=savebuf[ptr+17];

	ptr+=18; // restore game configuration
	scany =savebuf[ptr+0];
	fmov =savebuf[ptr+2];
	frot =savebuf[ptr+4];
	fdrop =savebuf[ptr+8];
	mdrop =savebuf[ptr+10];
	afig =savebuf[ptr+12];
	acol =savebuf[ptr+14];
	xfig =savebuf[ptr+16];
	yfig =savebuf[ptr+18];
	sfig =savebuf[ptr+20];
	lfig =savebuf[ptr+22];
	newfig=savebuf[ptr+24];
	figsize=savebuf[ptr+26];
	afignext=savebuf[ptr+28];
	acolnext=savebuf[ptr+29];

	ptr+=30; n=ptr; // restore game status
	asm push bx
	asm mov bx,n
	asm mov al,byte ptr savebuf[bx+0]
	asm mov byte ptr score[0],al
	asm mov al,byte ptr savebuf[bx+1]
	asm mov byte ptr score[1],al
	asm mov al,byte ptr savebuf[bx+2]
	asm mov byte ptr score[2],al
	asm mov al,byte ptr savebuf[bx+3]	//savebuf[ptr+0]= score;
	asm mov byte ptr score[3],al
	asm pop bx
	level =savebuf[ptr+4];
	difficulty =savebuf[ptr+6];
	scorex =savebuf[ptr+8];
	slines =savebuf[ptr+10];
	tlines =savebuf[ptr+12];

	ptr+=20;
	speed =savebuf[ptr+0];
	tempc =savebuf[ptr+2];
	tempd =savebuf[ptr+4];
	asm mov ax,tempd;
	asm movsx ax,al
	asm mov tempd,ax;
	tempn =savebuf[ptr+6];
	gameend =savebuf[ptr+8];
	maxstars =savebuf[ptr+10];

	ptr+=20;
	load_update();
	n=0;
l1:     key=0;
	setactivepage(1);
	screen=0xA960;
	sfig_count=0;
	return(n);
}


void load_update() {
	int n;
	int x,y;
	setcolour(15);
	if (mouseis==0) {
	setactivepage(0); screen=0xA000;
	if (mouseon==0) { box(207,383,235,397,2); print(214,386,"on"); }
	else { box(207,383,235,397,2); print(210,386,"off"); }
	setactivepage(1); screen=0xA960; }

	setcolour(15);
	if (musicis==0) {
	setactivepage(0); screen=0xA000;
	if (musicon==0) { box(251,383,279,397,2); print(258,386,"on"); }
	else { box(251,383,279,397,2); print(254,386,"off"); }
	osbvolume=setvolume(); maxvolume=sbvolume;
	setactivepage(1); screen=0xA960; }

	setcolour(15);
	setactivepage(0); screen=0xA000;
	if (gamemode==0) {
	box(410,372,444,394,2);
	setcolour(15); print(410,374,"MODE");
	setcolour(15); print(410,386,"HARD"); }
	else {
	box(410,372,444,394,2);
	setcolour(15); print(410,374,"MODE");
	setcolour(15); print(410,386,"EASY"); }
	setactivepage(1); screen=0xA960;

	initcolor(); n=gcorrect; gcorrect=0;
	while (n>0) { n--; gammacorrect(); }

	setcolour(15);
	setactivepage(0); screen=0xA000;
	if (radaron==1) {
	box(290,380,390,460,0);
	setcolour(6); print(310,413,"DISABLED");
	setcolour(7); print(309,412,"DISABLED");
	colour(1); linex(290,380,390,380); linex(290,380,290,460);
	colour(3); linex(290,460,390,460); linex(390,380,390,460);
	colour(10);for (y=390; y<460; y+=10) linex(291,y,389,y);
	colour(10);for (x=300; x<390; x+=10) linex(x,381,x,459); }
	else if (radaron==0) {
	box(290,380,390,460,0);
	colour(1); linex(290,380,390,380); linex(290,380,290,460);
	colour(3); linex(290,460,390,460); linex(390,380,390,460);
	colour(10);for (y=390; y<460; y+=10) linex(291,y,389,y);
	colour(10);for (x=300; x<390; x+=10) linex(x,381,x,459); }
	radar();
	setactivepage(1); screen=0xA960;

	definenextfigure(afignext);
	for(x=0; x<16; x++){ delay(1); syncdisplay(); volumedown(); }
	sbvolume=maxvolume;
	n=musictab[level-1];
	setmusic(n);
	makelevel();
	prlevel();
	prscore();
	prlines();
}


void drawcockpit() {
	int x,y,c;
	screen=0xA000;
	setactivepage(0);
	box(0,340,639,479,1); box(8,345,631,473,2);
	for(x=345; x<473; x+=2) {
	  for(y=8; y<631; y+=2) {
	     c=rand()&3;
	     asm mov ax,y;
	     asm mov bx,x;
	     asm mov cx,c;
	     plot(); } }
	colour(0); linex(0,479,639,479); linex(639,340,639,479);
	colour(2); linex(0,340,639,340); linex(0,340,0,479);
	colour(3); linex(8,473,631,473); linex(631,345,631,473);
	settextstyle(1,0,0);
	box(24,364,194,400,6); box(24,414,280,450,6);
	colour(1); linex(24,364,194,364); linex(24,364,24,400);
	colour(3); linex(24,400,194,400); linex(194,364,194,400);
	colour(1); linex(24,414,280,414); linex(24,414,24,450);
	colour(3); linex(24,450,280,450); linex(280,414,280,450);
	setcolour(8); print(32,360,"Lines: 0");
	setcolour(9); print(30,361,"Lines: 0");
	setcolour(12); print(32,410,"Score: 0");
	setcolour(13); print(30,411,"Score: 0");
	box(464,364,616,400,6); box(400,414,616,450,6);
	colour(1); linex(464,364,616,364); linex(464,364,464,400);
	colour(3); linex(464,400,616,400); linex(616,364,616,400);
	colour(1); linex(400,414,616,414); linex(400,414,400,450);
	colour(3); linex(400,450,616,450); linex(616,414,616,450);
	setcolour(8); print(472,360,"Level: 1");
	setcolour(9); print(470,361,"Level: 1");
	setcolour(12); print(406,410,"Lives: enough");
	setcolour(13); print(404,411,"Lives: enough");
	settextstyle(0,0,0);
	box(290,350,390,370,4);
	colour(3); linex(290,350,390,350); linex(290,351,290,370);
	colour(1); linex(390,350,390,370); linex(290,370,390,370);
	setcolour(8); print(298,358,"Space Radar");
	setcolour(14); print(296,356,"Space Radar");
	box(290,380,390,460,0);
	colour(1); linex(290,380,390,380); linex(290,380,290,460);
	colour(3); linex(290,460,390,460); linex(390,380,390,460);
	colour(10);for (y=390; y<460; y+=10) linex(291,y,389,y);
	colour(10);for (x=300; x<390; x+=10) linex(x,381,x,459);
	box(206,382,236,398,2);
	setcolour(15); print(201,370,"Mouse");
	colour(3); linex(206,382,206,398); linex(206,382,236,382);
	colour(1); linex(236,382,236,398); linex(206,398,236,398);
	setcolour(15);
	if (mouseon==0) { box(207,383,235,397,2); print(214,386,"on"); }
	else { box(207,383,235,397,2); print(210,386,"off"); }
	box(250,382,280,398,2);
	setcolour(15); print(247,370,"Music");
	colour(3); linex(250,382,280,382); linex(250,382,250,398);
	colour(1); linex(280,382,280,398); linex(250,398,280,398);
	setcolour(15);
	if (musicon==0) { box(251,383,279,397,2); print(258,386,"on"); }
	else { box(251,383,279,397,2); print(254,386,"off"); }
	box(403,370,448,400,2);
	colour(3); linex(402,370,448,370); linex(402,370,402,400);
	colour(1); linex(448,370,448,400); linex(402,400,448,400);
	if (gamemode==0) {
	setcolour(15); print(410,374,"MODE");
	setcolour(15); print(410,386,"HARD"); }
	else {
	setcolour(15); print(410,374,"MODE");
	setcolour(15); print(410,386,"EASY"); }
	setactivepage(1);
	screen=0xA960;
}


void definefigure(int i) {
	int n;
	switch (i) {
		case 0: {
			figsize=figsize0;
			for (n=0; n<figsize*figsize; n++) figtab[n]=figtab0[n];
			break;
		}
		case 1: {
			figsize=figsize1;
			for (n=0; n<figsize*figsize; n++) figtab[n]=figtab1[n];
			break;
		}
		case 2: {
			figsize=figsize2;
			for (n=0; n<figsize*figsize; n++) figtab[n]=figtab2[n];
			break;
		}
		case 3: {
			figsize=figsize3;
			for (n=0; n<figsize*figsize; n++) figtab[n]=figtab3[n];
			break;
		}
		case 4: {
			figsize=figsize4;
			for (n=0; n<figsize*figsize; n++) figtab[n]=figtab4[n];
			break;
		}
		case 5: {
			figsize=figsize5;
			for (n=0; n<figsize*figsize; n++) figtab[n]=figtab5[n];
			break;
		}
		case 6: {
			figsize=figsize6;
			for (n=0; n<figsize*figsize; n++) figtab[n]=figtab6[n];
			break;
		}
		case 7: {
			figsize=figsize7;
			for (n=0; n<figsize*figsize; n++) figtab[n]=figtab7[n];
			break;
		}
		case 8: {
			figsize=figsize8;
			for (n=0; n<figsize*figsize; n++) figtab[n]=figtab8[n];
			break;
		}
		case 9: {
			figsize=figsize9;
			for (n=0; n<figsize*figsize; n++) figtab[n]=figtab9[n];
			break;
		}
		case 10: {
			figsize=figsize10;
			for (n=0; n<figsize*figsize; n++) figtab[n]=figtab10[n];
			break;
		}
		case 11: {
			figsize=figsize11;
			for (n=0; n<figsize*figsize; n++) figtab[n]=figtab11[n];
			break;
		}
} }

void definenextfigure(int i) {
	int n,x,y,xx,yy;
	switch (i) {
		case 0: {
			figsizenext=figsize0;
			for (n=0; n<25; n++) figtabnext[n]=0; n=0;
			xx=0; yy=0;
			for (y=yy; y<figsizenext+yy; y++)
			for (x=xx; x<figsizenext+xx; x++) {
			figtabnext[x+y*5]=figtab0[n]; n++; }
			break;
		}
		case 1: {
			figsizenext=figsize1;
			for (n=0; n<25; n++) figtabnext[n]=0; n=0;
			xx=1; yy=1;
			for (y=yy; y<figsizenext+yy; y++)
			for (x=xx; x<figsizenext+xx; x++) {
			figtabnext[x+y*5]=figtab1[n]; n++; }
			break;
		}
		case 2: {
			figsizenext=figsize2;
			for (n=0; n<25; n++) figtabnext[n]=0; n=0;
			xx=1; yy=1;
			for (y=yy; y<figsizenext+yy; y++)
			for (x=xx; x<figsizenext+xx; x++) {
			figtabnext[x+y*5]=figtab2[n]; n++; }
			break;
		}
		case 3: {
			figsizenext=figsize3;
			for (n=0; n<25; n++) figtabnext[n]=0; n=0;
			if (figsizenext==3) { xx=1; yy=1;} else { xx=0; yy=0;}
			for (y=yy; y<figsizenext+yy; y++)
			for (x=xx; x<figsizenext+xx; x++) {
			figtabnext[x+y*5]=figtab3[n]; n++; }
			break;
		}
		case 4: {
			figsizenext=figsize4;
			for (n=0; n<25; n++) figtabnext[n]=0; n=0;
			if (figsizenext==3) { xx=1; yy=1;} else { xx=0; yy=0;}
			for (y=yy; y<figsizenext+yy; y++)
			for (x=xx; x<figsizenext+xx; x++) {
			figtabnext[x+y*5]=figtab4[n]; n++; }
			break;
		}
		case 5: {
			figsizenext=figsize5;
			for (n=0; n<25; n++) figtabnext[n]=0; n=0;
			if (figsizenext==3) { xx=1; yy=1;} else { xx=0; yy=0;}
			for (y=yy; y<figsizenext+yy; y++)
			for (x=xx; x<figsizenext+xx; x++) {
			figtabnext[x+y*5]=figtab5[n]; n++; }
			break;
		}
		case 6: {
			figsizenext=figsize6;
			for (n=0; n<25; n++) figtabnext[n]=0; n=0;
			if (figsizenext==3) { xx=1; yy=1;} else { xx=0; yy=0;}
			for (y=yy; y<figsizenext+yy; y++)
			for (x=xx; x<figsizenext+xx; x++) {
			figtabnext[x+y*5]=figtab6[n]; n++; }
			break;
		}
		case 7: {
			figsizenext=figsize7;
			for (n=0; n<25; n++) figtabnext[n]=0; n=0;
			xx=1; yy=2;
			for (y=yy; y<figsizenext+yy; y++)
			for (x=xx; x<figsizenext+xx; x++) {
			figtabnext[x+y*5]=figtab7[n]; n++; }
			break;
		}
		case 8: {
			figsizenext=figsize8;
			for (n=0; n<25; n++) figtabnext[n]=0; n=0;
			if (figsizenext==3) { xx=1; yy=1;} else { xx=0; yy=0;}
			for (y=yy; y<figsizenext+yy; y++)
			for (x=xx; x<figsizenext+xx; x++) {
			figtabnext[x+y*5]=figtab8[n]; n++; }
			break;
		}
		case 9: {
			figsizenext=figsize9;
			for (n=0; n<25; n++) figtabnext[n]=0; n=0;
			if (figsizenext==3) { xx=1; yy=1;} else { xx=0; yy=0;}
			for (y=yy; y<figsizenext+yy; y++)
			for (x=xx; x<figsizenext+xx; x++) {
			figtabnext[x+y*5]=figtab9[n]; n++; }
			break;
		}
		case 10: {
			figsizenext=figsize10;
			for (n=0; n<25; n++) figtabnext[n]=0; n=0;
			if (figsizenext==3) { xx=1; yy=1;} else { xx=0; yy=0;}
			for (y=yy; y<figsizenext+yy; y++)
			for (x=xx; x<figsizenext+xx; x++) {
			figtabnext[x+y*5]=figtab10[n]; n++; }
			break;
		}
		case 11: {
			figsizenext=figsize11;
			for (n=0; n<25; n++) figtabnext[n]=0; n=0;
			if (figsizenext==3) { xx=1; yy=1;} else { xx=0; yy=0;}
			for (y=yy; y<figsizenext+yy; y++)
			for (x=xx; x<figsizenext+xx; x++) {
			figtabnext[x+y*5]=figtab11[n]; n++; }
			break;
		}
} }

void defineobject(int i) {
	switch (i) {
		case 0: {
			ox=ox0;
			oy=oy0;
			oz=oz0;
			oln=oln0;
			opl=opl0;
			osf=osf0;
			points=opon0;
			lines=olin0;
			polys=opln0;
			break;
		}
		case 1: {
			ox=ox1;
			oy=oy1;
			oz=oz1;
			oln=oln1;
			opl=opl1;
			osf=osf1;
			points=opon1;
			lines=olin1;
			polys=opln1;
			break;
		}
		case 2: {
			ox=ox2;
			oy=oy2;
			oz=oz2;
			oln=oln2;
			opl=opl2;
			osf=osf2;
			points=opon2;
			lines=olin2;
			polys=opln2;
			break;
		}
		case 3: {
			ox=ox3;
			oy=oy3;
			oz=oz3;
			oln=oln3;
			opl=opl3;
			osf=osf3;
			points=opon3;
			lines=olin3;
			polys=opln3;
			break;
		}
		case 4: {
			ox=ox4;
			oy=oy4;
			oz=oz4;
			oln=oln4;
			opl=opl4;
			osf=osf4;
			points=opon4;
			lines=olin4;
			polys=opln4;
			break;
		}
		case 5: {
			ox=ox5;
			oy=oy5;
			oz=oz5;
			oln=oln5;
			opl=opl5;
			osf=osf5;
			points=opon5;
			lines=olin5;
			polys=opln5;
			break;
		}
		case 6: {
			ox=ox6;
			oy=oy6;
			oz=oz6;
			oln=oln6;
			opl=opl6;
			osf=osf6;
			points=opon6;
			lines=olin6;
			polys=opln6;
			break;
} } }


int enterlevel(void) {
	int i;
	int r=0;
	int n=0;
	key	= 0;
	kmouse	= 0;
	nokey	= 0;
	speed	= 5;
	level	= 1;
	maxstars=400;
	mesnum	= 40;
	inprinta= 0;
	inprintd= 10;
	inprintmax= 10;
	start_game= 0;
	settextstyle(1,0,0);
	initglass();
	fillglass(difficulty);
	makestars();
	do {	if (nokey!=0) nokey--;
		clearscreen();
		drawstars();
		plotglass();
		setcolour(12); print(191,121,"Enter Your Level:");
		setcolour(13); print(190,120,"Enter Your Level:");
		setcolour(12); print(235,241,"Difficulty:");
		setcolour(13); print(234,240,"Difficulty:");
		setcolour(3);
		for (i=1; i<6; i++) print(196+i*40,170,"%d",i);
		setcolour(14);
		print(196+level*40,170,"%d",level);
		print(402,240,"%d",difficulty);
		circle(203+level*40,191,16);
		setcolor(1); circle(203+level*40,191,15);
		setcolor(14);circle(409,261,16);
		setcolor(1); circle(409,261,15);
		if (sw_loadgame==1) { sw_loadgame=0; settextstyle(0,0,0); if (loadgame()==0) { syncdisplay(); start_game=1; return(0); } else settextstyle(1,0,0); }
		setcolour(15);
		settextstyle(0,0,0);
		printmessage(mesnum);
		settextstyle(1,0,0);
		copyscreen();
		if ((mouseis|mouseon)==0) {
		  asm { mov ax,0x0B
			int 0x33
			mov xmickey,cx
			mov ymickey,dx
			mov ax,0x03
			int 0x33
			mov kmouse,bx } }
		if (nokey==0) {
		if ((xmickey>8) && level<5) { nokey=3; level++; goto l1; }
		if ((xmickey<-8) && level>1) { nokey=3; level--; goto l1; }
		if (key==77 && level<5) { nokey=3; level++; goto l1; }
		if (key==75 && level>1) { nokey=3; level--; goto l1; }
		if (key==72 && difficulty<5) { nokey=4; difficulty++; fillglass(difficulty); }
		if (key==80 && difficulty>1) { nokey=4; difficulty--; fillglass(difficulty); }
		}
		goto l2;
l1:		makelevel();

l2:		if (key==0x1C) n=1;
		if (key==0x01) { r=1; n=1; }
		if (kmouse==1) n=1;
		if (kmouse==2) { r=1; n=1; }
		if (nokey==0) {
		 if (key==0x3B) { nokey=3; settextstyle(0,0,0); putmouse(); settextstyle(1,0,0); }
		 if (key==0x3C) { nokey=3; settextstyle(0,0,0); putmusic(); settextstyle(1,0,0); }
		 if (key==0x3D) { nokey=3; settextstyle(0,0,0); putmode(); settextstyle(1,0,0); }
		 if (key==0x3F) { nokey=3; settextstyle(0,0,0); if (loadgame()==0){ syncdisplay(); start_game=1; return(0);} else settextstyle(1,0,0); } }
		 if(key==0x41) { settextstyle(0,0,0); nokey=3; bosspage(); settextstyle(1,0,0); }
		 if(key==0x42) { settextstyle(0,0,0); nokey=3; bosspage(); settextstyle(1,0,0); }
	} while (n==0);

	if (r!=0) return(1);
	for (n=0; n<16; n++) {
		clearscreen();
		drawstars();
		plotglass();
		setcolour(12); print(191,121,"Enter Your Level:");
		setcolour(13); print(190,120,"Enter Your Level:");
		setcolour(12); print(235,241,"Difficulty:");
		setcolour(13); print(234,240,"Difficulty:");
		setcolour(3);
		for (i=1; i<6; i++) print(196+i*40,170,"%d",i);
		if(n&2) setcolour(14); else setcolour(2);
		print(196+level*40,170,"%d",level);
		print(402,240,"%d",difficulty);
		circle(203+level*40,191,16);
		circle(409,261,16);
		setcolor(1); circle(409,261,15);
		circle(203+level*40,191,15);
		setcolour(15);
		settextstyle(0,0,0);
		printmessage(mesnum);
		settextstyle(1,0,0);
		copyscreen();
		volumedown();
	}
	settextstyle(0,0,0);
	return(0);
}

void pause(void) {
	int n=0;
	syncdisplay();
	key=0;
	plotfig();
	for (n=0; n<8; n++) {
		clearscreen();
		drawstars();
		plotglass();
		settextstyle(1,0,0);
		setcolor(rand()&0x0F); outtextxy(272,160,"Paused");
		setcolor(rand()&0x0F); outtextxy(268,160,"Paused");
		setcolor(rand()&0x0F); outtextxy(270,160,"Paused");
		settextstyle(0,0,0);
		cockpit();
		shownextfig();
		copyscreen();
		fadein(); }
	do {	clearscreen();
		drawstars();
		plotglass();
		settextstyle(1,0,0);
		setcolor(rand()&0x0F); outtextxy(272,160,"Paused");
		setcolor(rand()&0x0F); outtextxy(268,160,"Paused");
		setcolor(rand()&0x0F); outtextxy(270,160,"Paused");
		settextstyle(0,0,0);
		cockpit();
		shownextfig();
		copyscreen();
	} while ((key|kmouse)==0);
	plotfig();
	key=0;
	delay(50);
	syncdisplay();
	initcolor();
	syncdisplay();
	initcolor(); n=gcorrect; gcorrect=0;
	while (n>0) { n--; gammacorrect(); }
	settextstyle(0,0,0);
}

void print(int x, int y, char *fmt, ...) {
	va_list argptr;
	va_start( argptr, fmt );
	vsprintf(string_buffer,fmt,argptr);
	outtextxy( x, y, string_buffer );
	va_end( argptr );
}

int printinbuf( char *fmt, ...) {
	va_list argptr;
	va_start( argptr, fmt );
	vsprintf(scsbuf,fmt,argptr);
	va_end( argptr );
	return( strlen(scsbuf));
}

void prlevel() {
	screen=0xA000;
	setactivepage(0);
	settextstyle(1,0,0);
	syncdisplay();
	box(560,370,610,393,6);
	setcolor(8); print(570,360,"%d",level);
	setcolor(9); print(568,361,"%d",level);
	settextstyle(0,0,0);
	setactivepage(1);
	screen=0xA960;
}

void prscore() {
	screen=0xA000;
	setactivepage(0);
	settextstyle(1,0,0);
	syncdisplay();
	box(134,420,278,443,6);
	setcolor(12); print(136,410,"%1.0f",score);
	setcolor(13); print(134,411,"%1.0f",score);
	settextstyle(0,0,0);
	setactivepage(1);
	screen=0xA960;
}

void prlines() {
	int n;
	screen=0xA000;
	setactivepage(0);
	settextstyle(1,0,0);
	syncdisplay();
	box(130,370,190,393,6);
	setcolor(8); print(132,360,"%d",slines);
	setcolor(9); print(130,361,"%d",slines);
	settextstyle(0,0,0);
	setactivepage(1);
	screen=0xA960;
	if (tlines>=linestab[level] && level!=leveltab[level]) {
		tlines=0;
		level=leveltab[level];
		lfig =lfigtab[level-1];
		prlevel();
		makelevel();
		for (n=0; n<16; n++) volumedown();
		if (musicon==0) sbvolume=maxvolume;
		n=musictab[level-1];
		setmusic(n);
		specmsg=1;
		mesnum=39+level;
		mesnumit=mesnum;
} }


void printmessage(int mesnum) {
	char *c;
	int n,b;
	if (inprinta==0) {
		if (mesnumold!=mesnum) {
			amsg=*msg;
			for (n=0; n<mesnum; n++) {
				while (*amsg!=0) amsg++;
				amsg++; }
			mesnumold=mesnum;
			inprint=1;
			inprintx=1; }
	inprinta=1; }
	if (inprint==1) {
		c=amsg;
		for (n=0; n<inprintx; n++) {
			message_string[n]=*c;
			c++; }
		message_string[n]=cursor; message_string[n+1]=0;
		outtextxy(32,330, message_string);
		if (inprintx<strlen(amsg)) inprintx++;
		else {	if (inprintd>0) inprintd--;
			else {  inprinta=0;
				inprintd=inprintmax;
	} } }
	if (curpas<0) {
		curpas=6;
		if (cursor==' ') cursor='_'; else cursor=' ';
	} else curpas--;
	if (sw_debug!=0) debug();
}

int loadscore() {
	int zzt,n,m,handle;
	if ( (handle=open(scorefile,O_RDWR | O_BINARY))==-1 ) scoreerror();
	if ( read(handle,scoretab,1024)==-1 ) scoreerror();
	if ( close(handle)==-1 ) scoreerror();
	delay(100);
	zzt=maxstars;
	maxstars=200;
	inprinta=0;
	inprintd=50;
	for (n=0; n<10; n++) {
		if (scoretab[13+n*16]<=score) {
			for (m=0; m<12; m++) scoretab[m+n*16]=32;
			scoretab[12+n*16]=gamemode;
			scoretab[13+n*16]=score;
			scoretab[14+n*16]=slines;
			scoretab[15+n*16]=level;
			goto l1;
		}
	}
	mesnum=20;
	goto l2;

l1:
	settextstyle(0,0,0);
	initscoretab();
	entername(n);
	if ( (handle=open(scorefile,O_RDWR))==-1 ) scoreerror();
	if ( write(handle,scoretab,1024)==-1 ) scoreerror();
	if ( close(handle)==-1 ) scoreerror();
l2:
	key=0;
	kmouse = 0;
	delay(50);
	settextstyle(0,0,0);
	initscoretab();
	do {
		clearscreen();
		drawstars();
		plotglass();
		setcolour(15);
		printmessage(mesnum);
		prscoretab();
		copyscreen();
		if((mouseis|mouseon)==0)
		{
			asm {
			mov ax,0x03
			int 0x33
			mov kmouse,bx }
		}
		m=key;
	}
	while ((m|kmouse)==0);
	maxstars=zzt;
	delay(50);
	return(m);
}


void prscoretab() {
	setcolor(13);
	outtextxy(220,20,"Best Pilotes Of The Galaxy");
	setcolor(14);
	outtextxy(144,70,scoretable[0]);
	outtextxy(144,90,scoretable[1]);
	outtextxy(144,110,scoretable[2]);
	outtextxy(144,130,scoretable[3]);
	outtextxy(144,150,scoretable[4]);
	outtextxy(144,170,scoretable[5]);
	outtextxy(144,190,scoretable[6]);
	outtextxy(144,210,scoretable[7]);
	outtextxy(144,230,scoretable[8]);
	outtextxy(144,250,scoretable[9]);
}

void initscoretab() {
	int n=0;
	int i,m,l;
	char *scs;
	char *scstemp;
	char hard[]="HARD";
	char easy[]="EASY";

	for (n=0; n<10; n++) {
		scstemp=scoretable[n]; scstemp+=5;
		scs=scstemp;
		for (m=0; m<strlen(scstemp); m++) { *scs=' '; scs++; }
		scs=scstemp;
		for (m=0; m<12; m++) { *scs=scoretab[m+n*16]; scs++; }
		scs=scstemp; scs+=15;
		l=(printinbuf( "%1.0f" , scoretab[13+n*16] ));
		for (m=0; m<l; m++) { *scs=scsbuf[m]; scs++; }
		scs=scstemp; scs+=24;
		i=scoretab[14+n*16];
		l=(printinbuf( "%d", i ));
		for (m=0; m<l; m++) { *scs=scsbuf[m]; scs++; }
		scs=scstemp; scs+=30;
		i=scoretab[15+n*16];
		l=(printinbuf( "%d", i ));
		for (m=0; m<l; m++) { *scs=scsbuf[m]; scs++; }
		scs=scstemp; scs+=34;
		i=scoretab[12+n*16];
		if (i==0) {
		 for (m=0; m<4; m++) { *scs=hard[m]; scs++; } }
		else {
		 for (m=0; m<4; m++) { *scs=easy[m]; scs++; } }
		*scs=0;
	}
}


void entername(int y) {
	int n,k;
	char sk;
	char str[16];

	n = 0;
	if (score>100000) mesnum=24;
	else if (score>50000) mesnum=23;
	else if (score>10000) mesnum=22;
	else mesnum=21;

	do {
l1:		str[n] = cursor;
		str[n+1] = 0;
		drawstars();
		plotglass();
		prscoretab();

		setcolor(15);
		printmessage(mesnum);
		setcolor(14);
		outtextxy(184,50+(y+1)*20,str);

		sk=key;
		k=keydecode(sk);
		str[n]=k;
		if(k==13)
		{
			while (n<12) str[n++]=32;
			str[n+1]=0;
			goto l2;
		}
		else if(k==12)
			if (n>0) str[n--]=32;

		if(--curpas<0)
		{
			curpas=5;
			if (cursor==32) cursor=95;
			else		cursor=32;
		}
		copyscreen();
		clearscreen();
		if (k<32) goto l1;
		if (k>128) goto l1;
		key = 0;
	} while(++n<12);
l2:     for (n=0; n<12; n++) scoretab[n+y*16]=str[n];
}

int keydecode(char c) {
	int n;
	char stb[]={
		1,1, 2,'1', 3,'2', 4,'3', 5,'4', 6,'5', 7,'6', 8,'7', 9,'8', 10,'9', 11,'0', 12,'+', 14,12,
		16,'Q', 17,'W', 18,'E', 19,'R', 20,'T', 21,'Y', 22,'U', 23,'I', 24,'O', 25,'P', 28,13,
		30,'A', 31,'S', 32,'D', 33,'F', 34,'G', 35,'H', 36,'J', 37,'K', 38,'L',
		44,'Z', 45,'X', 46,'C', 47,'V', 48,'B', 49,'N', 50,'M', 51,',', 52,'.', 57,' '
	};
	for (n=0; n<86; n+=2) if(c==stb[n]) return(stb[n+1]);
	return(0);
}

void maketab() {
	char *c;
	       //12345678901234
	char *s="NAREK......... ";
	int n,m;
	int lin=1000;
	int lev=10;
	int gmode=0; 	// gamemode HARD
	float scor=1000000;
	int handle;

	printf("\nWARNING!");
	printf("\nFile \"%s\" not found, creating a new one...\n", scorefile);

	_fmode = O_BINARY;
	if ( (handle=creat(scorefile, S_IREAD|S_IWRITE))==-1) {
		printf("\nFATAL ERROR: ",errno);
		printf("\nUnable to create file \"%s\"!", scorefile);
		printf("\nPress any key to abort the game and return to DOS\n\n");
		do delay (1); while (key==0);
		delay(50);
		toerror();
	}
	delay(100);
	for (n=0; n<16; n++) {
		scoretab[n*16+12]=gmode;
		scoretab[n*16+13]=scor;
		scoretab[n*16+14]=lin;
		scoretab[n*16+15]=lev;
		for (m=0; m<12; m++) scoretab[n*16+m]=s[m];
		scor=scor/2;
		lin=lin/2;
		lev=lev-1;
	}
	scoretab[9*16+13]=10;
	write (handle,scoretab, 1024);
	close (handle);
	delay(300);
}




//*************************************************************************
//	LEVELS: 1-10
//-------------------------------------------------------------------------

void makelevel(void) {
switch (level) {
	case 1:	speed=4; maxstars=300; makestars(); 	mesnum=40; break;
	case 2:	speed=6; maxstars=300; makefield(); 	mesnum=41; break;
	case 3:	speed=4; maxstars=160; makeland(); 	mesnum=42; break;
	case 4:	speed=2; maxstars=380; makeocean(); 	mesnum=43; break;
	case 5:	speed=5; maxstars=340; makefield(); 	mesnum=44; break;
	case 6:	speed=5; maxstars=300; makestars(); 	mesnum=45; break;
	case 7:	speed=9; maxstars=300; makestars(); 	mesnum=46; break;
	case 8:	speed=5; maxstars=160; makestars(); 	mesnum=47; break;
	case 9:	speed=9; maxstars=300; makestars(); 	mesnum=48; break;
	case 10: speed=9; maxstars=300; makestars(); 	mesnum=49; break;

} }


void drawstars(void) {
	if (background==0) {
	switch (level) {
		case 1:	plotstars(); 	break;
		case 2:	plotfield(); 	break;
		case 3: plotland(); 	break;
		case 4: plotocean(); 	break;
		case 5: plotbelt(); 	break;
		case 6: plotstars(); 	break;
		case 7: plotstars(); 	break;
		case 8: plotstars(); 	break;
		case 9: plotstars(); 	break;
		case 10: plotstars(); 	break;
	} }
	else {
	setcolour(13);
	settextstyle(0,0,0);
	if (tempc>20) { tempc=0; tempd*=-1; }
	tempc++; tempn+=tempd;
	outtextxy(260+tempn,8,"STAR TETRIS II"); }
}


void plotstars(void) {
	int n,c;
	int x,y,z;
	for (n=0; n<maxstars; n++) {
		z=matrzs[n];
		if (z>0) {
			x=xorigo+matrxs[n]*1024/z;
			y=yorigo+matrys[n]*1024/z;
			if (x>1)
			 if (x<639)
			  if (y>1)
			   if (y<339) {
				if (z<60) c=15;
				else if (z<100) c=3;
				else if (z<200) c=2;
				else c=1;
				asm mov ax,x;
				asm mov bx,y;
				asm mov cx,c;
				plot();
		} }
		matrzs[n]-=matrss[n];
		if(matrzs[n]<-50) {
			matrxs[n]=random(150)-75;
			matrys[n]=random(150)-75;
			matrzs[n]=random(500);
			matrss[n]=random(speed)+1;
} } }

void plotfield(void) {
	int n,c;
	int x,y,z;
	for (n=0; n<maxstars; n++) {
		z=matrzs[n];
		if (z>0) {
			x=xorigo+matrxs[n]*1024/z;
			y=yorigo+matrys[n]*1024/z;
			if (x>1)
			 if (x<639)
			  if (y>1)
			   if (y<339) {
				if (z<60) c=14;
				else if (z<100) c=11;
				else if (z<180) c=10;
				else c=1;
				asm mov ax,x;
				asm mov bx,y;
				asm mov cx,c;
				plot();
		} }

		matrzs[n]-=matrss[n];
		if(matrzs[n]<-50) {
			matrxs[n]=random(150)-75;
			matrys[n]=abs(random(.1)-2);
			matrzs[n]=random(200);
			matrss[n]=random(speed)+1;
} } }

void plotocean(void) {
	int n,c;
	int x,y,z;
	n=rand()&1;
	setcolour(12); circle(410,50+n,30);
	for (n=0; n<maxstars; n++) {
		z=matrzs[n];
		if (z>0) {
			x=xorigo+matrxs[n]*1024/z;
			y=yorigo+3*256/z;
			if (x>1)
			 if (x<638)
			  if (y>1)
			   if (y<339) {
				if (z<30) {
				asm mov ax,x; asm mov bx,y; asm mov cx,9;
				plot();
				x++;
				asm mov ax,x; asm mov bx,y; asm mov cx,9;
				plot(); }
				else if (z<60) {
				asm mov ax,x; asm mov bx,y; asm mov cx,9;
				plot(); }
				else if (z<120) {
				asm mov ax,x; asm mov bx,y; asm mov cx,8;
				plot(); }
				else {
				asm mov ax,x; asm mov bx,y; asm mov cx,1;
				plot(); }
		} }
		matrzs[n]-=matrss[n];
		if(matrzs[n]<-50) {
			matrxs[n]=random(150)-75;
			matrzs[n]=random(200);
			matrss[n]=random(speed)+1;
} } }

void plotland(void) {
	int n,x,y,c;
	float z;
	n=rand()&1;
	colour(6);
	linex(0,170+n,110,20+n);
	linex(110,20+n,210,130+n);
	linex(190,160+n,241,90+n);
	linex(241,90+n,290,166+n);
	linex(420,170+n,490,50+n);
	linex(490,50+n,510,70+n);
	linex(460,160+n,532,30+n);
	linex(532,30+n,600,150+n);
	linex(578,110+n,630,40+n);

	for (n=0; n<32; n++) {
	x=matrxs[n]; y=matrys[n]; c=matrzs[n];
	asm mov ax,x
	asm mov bx,y
	asm mov cx,c
	plot(); }

	for (n=0; n<32; n++) {
		z=matrls[n];
		matrls[n]-=.15;
		if (z>0) {
			y=yorigo+2*(256/z)-10;
			if (y>1) if (y<339) {
				if (z<5) c=15;
				else if (z<21) c=3;
				else if (z<27) c=2;
				else c=1;
				asm mov ax,1;
				asm mov dx,639;
				asm mov bx,y;
				asm mov cx,c;
				hline();
			}
		} else matrls[n]=32;
} }

void plotbelt(void) {
	int n,c;
	int x,y,z;
	for (n=0; n<maxstars; n++) {
		z=matrzs[n];
		if (z>0) {
			x=xorigo+matrxs[n]*1024/z;
			y=yorigo+matrys[n]*1024/z;

			if (x>1)
			 if (x<638)
			  if (y>1)
			   if (y<338) {
				if (z<50) {
				c=13+(rand()&1);
				asm mov ax,x; asm mov bx,y; asm mov cx,c;
				plot();
				x++;
				asm mov ax,x; asm mov bx,y; asm mov cx,c;
				plot(); }
				else if (z<70) {
				asm mov ax,x; asm mov bx,y; asm mov cx,15;
				plot(); }
				else if (z<110) {
				asm mov ax,x; asm mov bx,y; asm mov cx,3;
				plot(); }
				else if (z<200) {
				asm mov ax,x; asm mov bx,y; asm mov cx,2;
				plot(); }
				else {
				asm mov ax,x; asm mov bx,y; asm mov cx,1;
				plot(); }
		} }
		matrzs[n]-=matrss[n];
		if(matrzs[n]<-50) {
			matrxs[n]=random(150)-75;
			matrys[n]=random(150)-75;
			matrzs[n]=random(500);
			matrss[n]=random(speed)+1;
	} }
	if (tempc>9) { tempc=0; tempd*=-1; }
	tempc++; tempn+=tempd;
	setcolor(5); setfillstyle(6,4);
	fillellipse(300,70+tempn,40,40);
}







void makestars(void) {
	int n;
	for(n=0; n<512; n++) {
		matrxs[n]=random(150)-75;
		matrys[n]=random(150)-75;
		matrzs[n]=random(500);
		matrss[n]=random(speed)+1;
} }

void makefield(void) {
	int n;
	for(n=0; n<512; n++) {
		matrxs[n]=random(150)-75;
		matrys[n]=abs(random(0.1)-2);
		matrzs[n]=random(200);
		matrss[n]=random(speed)+1;
} }

void makeocean(void) {
	int n;
	for(n=0; n<512; n++) {
		matrxs[n]=random(150)-75;
		matrzs[n]=random(200);
		matrss[n]=random(speed)+1;
} }

void makeland(void) {
	int n;
	for(n=0; n<32; n++) {
		matrxs[n]=50+rand()&0x1ff;
		matrys[n]=rand()&0x07f;
		matrzs[n]=rand()&0x003;
		if (matrzs[n]==0) matrzs[n]=1;
		matrls[n]=n;
} }





//===========================================================================
void helppage(void)
{
	syncdisplay();
}

//===========================================================================
void bosspage(void)
{
	char n;
	int m;
	int vol;
	int drv = VGA;
	int mod = VGAHI;

	syncdisplay();
	vol = sbvolume;
	sbvolume = 0;
	setvolume();

	setactivepage(0);
	screenoff();
	closegraph();
	screenon();
	asm mov ax,3
	asm int 0x10

	printf("Calculating matrix mA, f(x) = 2^e / sin(b*c - a*d) * w^2\n");
	printf("========================================================\n");
	printf("\n  f'(x) = cos(-e^2 * 1/w);  t' >= -1 >= t'(x)\n");
	printf("\n  found common denominator x = PI * bin(2..5)\n");
	printf("  performing multiplication...\n");
	printf("  100%% complete (n result found for bin(2) denominator)\n");
	printf("f(x)[lim -> bin(2)] = %1.6f\n", random(9)/PI);
	printf("  100%% complete (n result found for bin(3) denominator)\n");
	printf("f(x)[lim -> bin(3)] = %1.6f\n", random(9)/PI);
	printf("  100%% complete (n result found for bin(4) denominator)\n");
	printf("f(x)[lim -> bin(4)] = %1.6f\n", random(9)/PI);
	printf("  100%% complete (n result found for bin(5) denominator)\n");
	printf("f(x)[lim -> bin(5)] = %1.6f\n", random(9)/PI);

	printf("\nPerforming 2nd stage calculations...\n");
	printf("------------------------------------\n  ");
	n = m = key = 0;
	do {
		delay(50);
		if(n++ == 0)
			printf("%3d%% complete\b\b\b\b\b\b\b\b\b\b\b\b\b", m++);
	} while(key==0);

	screenoff();
	initgraph( &drv, &mod, "");
	screenoff();
	setactivepage(0);
	cleardevice();
	setactivepage(1);
	initcolor();
	drawcockpit();
	syncdisplay();
	screenon();
	prlevel();
	prscore();
	prlines();

	sbvolume = vol;
	setvolume();
	syncdisplay();
}


//===========================================================================
// SYSTEM INITIALIZATION
//---------------------------------------------------------------------------
void snslogo(void) {
	int n=0;
	int x=0;
	int y=0;
	char *msg1="Supernar Systems";
	char *msg2="Production";
	screenoff();
	setactivepage(0);
	cleardevice();
	setrgb(56,0,0,0);     // color 8 black
	setrgb(57,1,1,1);     // color 9 black+
	setrgb(58,2,2,2);     // color 10 black++
	setrgb(59,3,3,3);     // color 11 black+++
	setrgb(60,4,4,4);
	setrgb(61,5,5,5);
	setrgb(62,6,6,6);
	setrgb(63,7,7,7);
	setrgb(0,0,0,0);     // color 0 black
	setrgb(1,0,0,0);     // color 1 black+
	setrgb(2,0,0,0);     // color 2 black++
	setrgb(3,0,0,0);     // color 3 black+++
	setrgb(4,14,0,0);
	setrgb(5,24,0,0);
	setrgb(20,36,0,0);
	setrgb(7,58,0,0);

	n=8;
	for(y=0; y<480; y+=2) {
	for(x=0; x<640; x+=2) {
	n=8+(rand()&7);
	asm mov ax,x
	asm mov bx,y
	asm mov cx,n
	plot(); } }

	settextstyle(1,0,0);
	setcolour(1);
	print(180-2,150-2,msg1);
	print(234-2,190-2,msg2);
	print(180+2,150-2,msg1);
	print(234+2,190-2,msg2);
	print(180-2,150+2,msg1);
	print(234-2,190+2,msg2);
	print(180+2,150+2,msg1);
	print(234+2,190+2,msg2);
	settextstyle(0,0,0);
	print(456+2,150+2,"TM");
	setcolour(2);
	settextstyle(1,0,0);
	print(180-1,150-1,msg1);
	print(234-1,190-1,msg2);
	print(180+1,150-1,msg1);
	print(234+1,190-1,msg2);
	print(180-1,150+1,msg1);
	print(234-1,190+1,msg2);
	print(180+1,150+1,msg1);
	print(234+1,190+1,msg2);
	settextstyle(0,0,0);
	print(456,150,"TM");
	setcolour(3);
	settextstyle(1,0,0);
	print(180,150,msg1);
	print(234,190,msg2);
	syncdisplay();
	screenon();
	for(n=0; n<42; n++) {
		syncdisplay();
		setrgb(1,n/3,n/3,0);
		setrgb(2,n/1.5,n/1.5,0);
		setrgb(3,n,n,0); }
	for(n=12; n<208; n++) {
		delay(3);
		colour(5);
		linex(200+n,230,204+n,230);
		colour(4);
		linex(201+n,231,205+n,231);
		colour(5);
		linex(200+n,232,204+n,232);
		colour(5);
		linex(204+n,230,207+n,230);
		linex(205+n,231,208+n,231);
		linex(204+n,232,207+n,232);
		colour(6);
		linex(207+n,230,209+n,230);
		linex(208+n,231,210+n,231);
		linex(207+n,232,209+n,232);
		colour(7);
		linex(209+n,230,210+n,230);
		linex(210+n,231,211+n,231);
		linex(209+n,232,210+n,232); }
	for(n=0; n<14; n++) {
		delay(10);
		syncdisplay();
		colour(1);
		linex(402,200-n-3,402,200+n+3);
		linex(402-n/1.5-3,200,402+n/1.5+3,200);
		colour(2);
		linex(402,200-n-2,402,200+n+2);
		linex(402-n/1.5-2,200,402+n/1.5+2,200);
		colour(3);
		linex(402,200-n-1,402,200+n+1);
		linex(402-n/1.5-1,200,402+n/1.5+1,200);
		putpixel(402-1,200-1,2); putpixel(402-1,200+1,2);
		putpixel(402+1,200-1,2); putpixel(402+1,200+1,2);
		putpixel(402,200,7); }
		delay(50);
		syncdisplay();
	for(n=14; n>3; n--) {
		delay(25);
		colour(0);
		linex(402,200-n/1.1-4, 402,200+n+4);
		linex(402-n/1.5-4,200, 402+n/1.5+4,200);
		colour(1);
		linex(402,200-n/1.1-3, 402,200+n+3);
		linex(402-n/1.5-3,200, 402+n/1.5+3,200);
		colour(2);
		linex(402,200-n/1.1-1, 402,200+n+1);
		linex(402-n/1.5-1,200, 402+n/1.5+1,200);
		putpixel(402-1,200-1,2); putpixel(402-1,200+1,2);
		putpixel(402+1,200-1,2); putpixel(402+1,200+1,2);
		putpixel(402,200,7); }
		putpixel(402-2,200-2,1); putpixel(402-2,200+2,1);
		putpixel(402+2,200-2,1); putpixel(402+2,200+2,1);
		delay(1100);
		syncdisplay();
	for(n=0; n<64; n++) { delay(23); syncdisplay(); fadein(); }
	settextstyle(0,0,0);
	setactivepage(0);
	cleardevice();
	delay(900);
	syncdisplay();
}

//---------------------------------------------------------------------------
void st2logo()
{
	printf("                             STAR TETRIS II  v%s                             \n", version);
	printf("                            ***********************                           \n");
	asm {
		push	ds
		mov	ax,0xB800
		mov	ds,ax
		mov	di,1
		mov	cx,80*2
		mov	al,0x1F
	@@1:	mov	ds:[di],al
		add	di,2
		loop	@@1
		pop	ds
	}
}


//===========================================================================
void systeminit(void) {
	int h;
	int drv = VGA;
	int mod = VGAHI;
	unsigned int n;
	unsigned char x1,x2,x3;

	st2logo();
	delay(300);

	printf("\n");
	printf(" System_Init: \n");
	printf("==============\n");

	printf("  CPU_Init   ");
	n = cpudetect();
	switch(n)
	{
		case 0x8086:
			cpu_type=1;
			printf("Intel 8086 processor or compatible detected.\n");
			printf("FATAL ERROR!\n");
			printf("This game requires at least an 80386 processor!\n");
			exit(1);
			break;
		case 0x0286:
			cpu_type=2;
			printf("Intel 80286 processor or compatible detected.\n");
			printf("FATAL ERROR!\n");
			printf("This game requires an 80386 machine or better!\n");
			break;
		case 0x0386:
			cpu_type=3;
			printf("Intel 80386 processor or compatible detected.\n");
			printf("WARNING:  no active L1 cache!\n");
			printf("The game may run too slow on this machine because of an old processor!\n");
			break;
		case 0x0486:
			cpu_type=4;
			printf("Intel 80486 processor or compatible detected.\n");
			break;
		case 0x0586:
			cpu_type=5;
			printf("Intel Pentium processor or compatible detected.\n");
			break;
		case 0x0686:
			cpu_type=6;
			printf("Intel Pentium Pro or Pentium II processor detected.\n");
			break;
		case 0x0786:
			cpu_type=7;
			printf("Intel Pentium III or compatible processor detected.\n");
			break;
		case 0xFFFF:
			cpu_type=0;
			printf("WARNING! Unknown CPU detected, trying to hold on!\n");
			break;
	}
	delay(100);

	printf("  DOS_Init   ");
	chk_dosver();
	asm mov x1,bl
	asm mov x2,ah
	asm mov x3,al
	asm mov dos_bl,bl
	asm mov dos_ah,ah
	asm mov dos_al,al
	printf("Present Operating System is MS-DOS %c.%c%c or compatible.\n",x1,x2,x3);
	if (x1<'5')
	{
		printf("\nSYSTEM REPORTING:\nThis program requires MS-DOS 5.0 or higher!\nProgram Aborted!\n");
		exit(1);
	}
	delay(100);

	printf("  DPMI_Init  ");
	n = run_al = chk_system();
	if (n==0) printf("No DPMI found. Running under BIOS\n");
	if (n==1) printf("No DPMI found. Running under XMS\n");
	if (n==2) printf("No DPMI found. Running under VCPI\n");
	if (n==3) printf("DPMI found. Ignoring DOS Protected Mode Interface services.\n");
	if (n==4) printf("Unknown memory manager running in protected mode.\n");
	delay(100);

	printf("  MEM_Init   Allocating additional memory: ");
	n = initmem1();
	if (n==NULL)
	{
		printf("<NULL>\nSYSTEM REPORTING:\nNot enough free memory available in the system!\nProgram Aborted!\n");
		exit(1);
	}
	printf("0x%04X:0000, ", n);
	n = initmem2();
	if (n==NULL)
	{
		printf("<NULL>\nSYSTEM REPORTING:\nNot enough free memory available in the system!\nProgram Aborted!\n");
		exit(1);
	}
	printf("0x%04X:0000", n);
	printf("\n");
	delay(300);

	printf("  IRQ_Init   Installing custom interrupts: ");
	delay(100);
	timeint=_dos_getvect(8);
	_dos_setvect(8,timer);
	printf("IRQ 0 (TIMER), ");
	biosint=_dos_getvect(9);
	_dos_setvect(9,inkey);
	printf("IRQ 1 (KEYBOARD)");
	printf("\n");
	delay(100);

	if (sw_nomouse==0)
	{
		printf("  MOUSE_Init");
		mouseis=mouseinit();
		if (mouseis==0)
		{
			mouseon=0;
			printf("   Attached mouse device detected, initializing driver.\n");
		}
		else
		{
			mouseon=1;
			printf("   No attached mouse device detected or driver not installed.\n");
		}
	}
	else
	{
		mouseis=1;
		mouseon=1;
	}

	if (sw_nomusic==0)
	{
		printf("  SOUND_init");
		musicis=musicinit();
		if (musicis==0)
		{
			musicon=0;
			printf("   Sound Blaster audio card or compatible found.\n");
		}
		else
		{
			musicon=1;
			printf("   Sound Blaster audio card or compatible NOT found.\n");
		}
	}
	else
	{
		musicis=1;
		musicon=1;
	}
	delay(100);

	printf("  GRAPHICS_Init\n");
	n = chk_video();
	delay(100);
	if(n==1)
	{
		printf(" \nSYSTEM REPORTING:\nStandard VGA BIOS software/hardware not detected.\nProgram Aborted!");
		exit(1);
	}
	printf("   + VGA BIOS detected.\n");
	delay(50);
	if(n==2) printf("   + VESA VBE support NOT detected.\n");
	else	 printf("   + VESA VBE support detected.\n");

	printf("   + Dynamically linking to Borland Graphics Interface.\n");
	delay(50);
	registerfarbgidriver(*(EGAVGA_driver));
	registerfarbgifont(*(triplex_font));
	printf("   + BGI VGA_HIGH (VGA 640x480x16 mode) driver attached.\n");
	delay(100);

l1:	if ( (h=open(scorefile,O_RDWR | O_BINARY))==-1 )
	{
		maketab();
		goto l1;
	}
	if ( read(h,scoretab,1024)==-1 )
	{
		maketab();
		goto l1;
	}
	if ( close(h)==-1 )
	{
		maketab();
		goto l1;
	}

	if (musicis==0)
	{
		printf("  MUSIC_Init  Loaded STAR TETRIS II Music Library.\n");
		delay(100);

		n = initmusic();
		if (n!=0)
		{
			printf("\nSYSTEM REPORTING:\nMusic library file \"%s\" could not be found!\nProgram Aborted!\n", musicfile);
			_dos_setvect(8,timeint);
			_dos_setvect(9,biosint);
			exit(1);
		}
	}

	if(sw_debug != 0)
	{
		printf("  DEBUG_Init  Debug/Verbose modes enabled.\n");
		delay(100);
	}

	printf("\n\nStand by...");
	delay(1000);

	do delay(1); while (key==29);
	for(n=0; n<64; n++) { delay(10); fadein(); }

	screenoff();
	initgraph( &drv, &mod, "");
	screenoff();
	setactivepage(0);
	cleardevice();
	asm cld
	if (musicis==0)
	{
		asm {
			mov dx,sbport
			add dx,0x0004
			mov ax,0x0026
			out dx,al
			mov dx,sbport
			add dx,0x0005
			in al,dx
			and ax,0x000F
			mov sbvolume,ax
			mov maxvolume,ax
		};
		oldsbvolume = setvolume();
		setvolume();
	}
	asm {
		push ax
		mov al,00h
		out 43h,al
		mov al,0xff
		out 40h,al
		out 40h,al
		xor ax,ax
		mov fs,ax
		mov gs,ax
		pop ax
	}
	screenon();
};




/****************************************************************************/
void debug(void) {
	setcolor(7);
	print( 0,0,"_level %d",level);
	print( 0,8,"_difficulty %d",difficulty);
	print( 0,16,"_scorex %d",scorex);
	print( 0,24,"_score %f",score);
	print( 0,32,"_slines %d",slines);
	print( 0,40,"_tlines %d",tlines);

	print( 0,64,"_figsize %d",figsize);
	print( 0,72,"_xfig %d",xfig);
	print( 0,80,"_yfig %d",yfig);
	print( 0,88,"_sfig %d",sfig);
	print( 0,96,"_scany %d",scany);
	print( 0,104,"_fmov %d",fmov);
	print( 0,112,"_frot %d",frot);
	print( 0,120,"_fdrop %d",fdrop);
	print( 0,128,"_mdrop %d",mdrop);
	print( 0,136,"_afig %d",afig);
	print( 0,144,"_acol %d",acol);
	print( 0,152,"_lfig %d",lfig);
	print( 0,160,"_newfig %d",newfig);

	print( 0,184,"_objects %d",objects);
	print( 0,192,"_points %d",points);
	print( 0,200,"_lines %d",lines);
	print( 0,208,"_polys %d",polys);

	print( 0,224,"_key %d",key);
	print( 0,232,"_frkey %d",frkey);
	print( 0,240,"_flkey %d",flkey);
	print( 0,248,"_oldkey %d",oldkey);
	print( 0,256,"_nokey %d",nokey);
	print( 0,264,"_xmickey %d _ymickey %d",xmickey,ymickey);
	print( 0,272,"_xmouse %d _ymouse %d",xmouse,ymouse);
	print( 0,280,"_kmouse %d",kmouse);
	print( 0,288,"_okmouse %d",okmouse);
	print( 0,296,"_mesnum %d",mesnum);
	print( 0,304,"_inprintx %d",inprintx);

	print( 500, 0,"_g_count %d",g_count);
	print( 500, 8,"_g_seconds %d",g_seconds);
	print( 500,16,"_g_minutes %d",g_minutes);
	print( 500,24,"_g_hours %d",g_hours);
	print( 500,32,"_p_count %d",p_count);
	print( 500,40,"_p_seconds %d",p_seconds);
	print( 500,48,"_p_minutes %d",p_minutes);
	print( 500,56,"_p_hours %d",p_hours);
}


/****************************************************************************/
void toerror(void) {
	unsigned int n;
	unsigned long l;
	delay(100);
	resetplayer();
	sbvolume=oldsbvolume;
	setvolume();
	_dos_setvect(8,timeint);
	_dos_setvect(9,biosint);
	setactivepage(0);
	closegraph();
	printf("SYSTEM REPORTING:\n");
	printf("Breakpoint in program has been reached!\n\n");
	asm mov n,cs
	printf("CS=        %04X \n",n);
	asm mov n,ds
	printf("DS=        %04X \n",n);
	asm mov n,es
	printf("ES=        %04X \n",n);
	asm mov n,ss
	printf("SS=        %04X \n",n);
	asm mov l,esi
	printf("ESI=   %08X \n",l);
	asm mov l,edi
	printf("EDI=   %08X \n",l);
	asm mov l,esp
	printf("ESP=   %08X \n",l);
	exit(1);
}



/****************************************************************************/
void loaderror(void)
{
	common_error();
	printf("Failed initializing music library! Program Aborted!\n\n");
	exit(1);
}

void scoreerror(void)
{
	common_error();
	printf("Failed reading score file! Program Aborted!\n\n");
	exit(1);
}

void save_error(void)
{
	common_error();
	printf("Failed saving file on disk! Program Aborted!\n\n");
	exit(1);
}

void load_error(void)
{
	common_error();
	printf("Failed loading file from disk! Program Aborted!\n\n");
	exit(1);
}

void load_error2(void)
{
	common_error();
	printf("Incorrect format of saved file! Program Aborted!\n\n");
	exit(1);
}

void load_error3(void)
{
	common_error();
	printf("Incorrect version of saved file! Program Aborted!\n\n");
	exit(1);
}

void common_error(void)
{
	delay(100);
	resetplayer();
	sbvolume=oldsbvolume;
	setvolume();
	_dos_setvect(8,timeint);
	_dos_setvect(9,biosint);
	setactivepage(0);
	closegraph();
	asm mov ax,3
	asm int 0x10
	printf("SYSTEM REPORTING:\n");
}
